var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import React from 'react';
import classNames from 'classnames';
import AccordionItem from './Item';
import { isEmptyArray } from '../utils/string';

var Accordion =
/** @class */
function (_super) {
  __extends(Accordion, _super);

  function Accordion(props) {
    var _this = _super.call(this, props) || this;

    _this.prefixCls = 're-accordion';
    /** *
     * 展开下拉链接列表
     * @param name
     */

    _this.onVisibleChange = function (name) {
      var _a, _b;

      var _c = _this.props,
          interactive = _c.interactive,
          beforeVisibleChange = _c.beforeVisibleChange,
          onVisibleChange = _c.onVisibleChange;

      if (beforeVisibleChange) {
        beforeVisibleChange(name);
      }

      var visibleNames = _this.state.visibleNames;
      var isCurVisible = visibleNames[name];

      if (interactive) {
        // 能同时展开多项，只对当前项做展开/闭合操作
        _this.setState({
          visibleNames: __assign(__assign({}, visibleNames), (_a = {}, _a[name] = !isCurVisible, _a))
        });
      } else {
        // 每次只能展开一项
        _this.setState({
          visibleNames: (_b = {}, _b[name] = !isCurVisible, _b)
        });
      }

      if (onVisibleChange) {
        onVisibleChange(name, !isCurVisible);
      }
    };

    var visibleNames = {};
    var defaultVisibleNames = props.defaultVisibleNames;

    if (!isEmptyArray(defaultVisibleNames)) {
      defaultVisibleNames.forEach(function (name) {
        visibleNames[name] = true;
      });
    }

    _this.state = {
      visibleNames: visibleNames
    };
    return _this;
  }

  Accordion.prototype.render = function () {
    var _this = this;

    var cls = this.prefixCls;
    var _a = this.props,
        className = _a.className,
        children = _a.children;
    var visibleNames = this.state.visibleNames;
    return React.createElement("ul", {
      className: classNames(cls, className)
    }, React.Children.map(children, function (child) {
      var name = child.props.name;
      return React.cloneElement(child, {
        key: name,
        onTitleClick: function onTitleClick() {
          _this.onVisibleChange(name);
        },
        visible: !!visibleNames[name]
      });
    }));
  }; // 限制用户传入的参数，所以用BaseAccordionItemProps


  Accordion.Item = AccordionItem;
  Accordion.defaultProps = {
    className: '',
    interactive: true,
    defaultVisibleNames: []
  };
  return Accordion;
}(React.Component);

export default Accordion;