import React from 'react';
import classNames from 'classnames';
import { CSSTransition } from 'react-transition-group';
import Portal from '../portal';

function PortalAffix(_a, ref) {
  var cls = _a.prefixCls,
      visible = _a.visible,
      children = _a.children,
      top = _a.top,
      left = _a.left,
      width = _a.width,
      className = _a.className,
      fadeEffect = _a.fadeEffect;
  var style = {
    top: top,
    left: left,
    width: width
  };

  if (fadeEffect) {
    return React.createElement(Portal, null, React.createElement(CSSTransition, {
      in: visible,
      timeout: 200,
      classNames: cls + "-fade",
      appear: true
    }, React.createElement("div", {
      style: style,
      ref: ref,
      className: classNames(className, cls + "-custom")
    }, children)));
  }

  style.display = visible ? '' : 'none';
  return React.createElement(Portal, null, React.createElement("div", {
    style: style,
    ref: ref,
    className: classNames(className, cls + "-custom")
  }, children));
}

export default React.forwardRef(PortalAffix);