var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import React from 'react';
import { Transition } from 'react-transition-group';
import classNames from 'classnames';

function Child(_a, ref) {
  var _b;

  var cls = _a.prefixCls,
      visible = _a.visible,
      children = _a.children,
      width = _a.width,
      height = _a.height,
      className = _a.className,
      placement = _a.placement,
      closable = _a.closable,
      onEnter = _a.onEnter,
      onExited = _a.onExited,
      onCancel = _a.onCancel;
  var enterStyle = {
    transform: 'translate(0, 0)'
  };
  var exitStyle = {
    transform: ''
  };
  var contentStyle = (_b = {}, _b[placement] = '0px', _b);

  if (placement === 'left' || placement === 'right') {
    contentStyle.width = width;
    contentStyle.height = '100%';
    contentStyle.top = '0px';
    exitStyle.transform = "translate(" + (placement === 'right' ? '100%' : '-100%') + ", 0)";
  } else if (placement === 'top' || placement === 'bottom') {
    contentStyle.width = '100%';
    contentStyle.height = height;
    contentStyle.left = '0px';
    exitStyle.transform = "translate(0, " + (placement === 'bottom' ? '100%' : '-100%') + ")";
  }

  var transitionStyles = {
    entering: enterStyle,
    entered: enterStyle,
    exiting: exitStyle,
    exited: exitStyle
  };
  return React.createElement(Transition, {
    in: visible,
    timeout: 200,
    appear: true,
    onEnter: onEnter,
    onExited: onExited
  }, function (state) {
    return React.createElement("div", {
      style: __assign(__assign({}, contentStyle), transitionStyles[state]),
      ref: ref,
      className: classNames(cls, className)
    }, closable ? React.createElement("span", {
      className: cls + "-times",
      onClick: onCancel
    }, "\xD7") : null, children);
  });
}

export default React.forwardRef(Child);