var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import React from 'react';
import Portal from '../portal';
import { hasVerticalScrollbar } from '../utils/string';
import { getScrollBarSize } from '../utils/getScrollBarSize';
import Mask from '../mask';
import Child from './Child';

var Drawer =
/** @class */
function (_super) {
  __extends(Drawer, _super);

  function Drawer() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.prefixCls = 're-drawer';
    _this.childRef = React.createRef();

    _this.onClose = function () {
      var _a = _this.props,
          maskClosable = _a.maskClosable,
          onClose = _a.onClose,
          name = _a.name;

      if (maskClosable && onClose) {
        onClose(false, name);
      }
    };

    _this.onCancel = function () {
      var _a = _this.props,
          onClose = _a.onClose,
          name = _a.name;

      if (onClose) {
        onClose(false, name);
      }
    }; // 用于标志是否弹出，防止在单页面应用时，没有onEnter，但是在销毁时执行onExited


    _this.isEnter = false;

    _this.onEnter = function () {
      _this.isEnter = true;
      var currentDocument = window.document.body;
      var hiddenScroll = _this.props.hiddenScroll;

      if (hiddenScroll) {
        currentDocument.style.overflow = 'hidden';
        var scrollSize = getScrollBarSize();

        if (hasVerticalScrollbar(scrollSize)) {
          currentDocument.style.paddingRight = scrollSize + "px";
        }
      }
    };

    _this.onExited = function () {
      if (!_this.isEnter) {
        return;
      }

      var currentDocument = window.document.body;
      var hiddenScroll = _this.props.hiddenScroll;

      if (hiddenScroll && currentDocument) {
        currentDocument.style.overflow = '';
        currentDocument.style.paddingRight = '';
      }

      var _a = _this.props,
          onDestroy = _a.onDestroy,
          name = _a.name;

      if (onDestroy) {
        onDestroy(name);
      }
    };

    return _this;
  }

  Drawer.prototype.componentWillUnmount = function () {
    // 销毁时，如果没有执行onExited，则在此执行
    this.onExited();
  };

  Drawer.prototype.render = function () {
    var _a = this.props,
        visible = _a.visible,
        children = _a.children,
        showMask = _a.showMask,
        extraProps = __rest(_a, ["visible", "children", "showMask"]);

    if (visible || this.childRef.current) {
      return React.createElement(Portal, null, React.createElement(React.Fragment, null, showMask ? React.createElement(Mask, {
        onClose: this.onClose,
        visible: visible,
        timeout: 300
      }) : null, React.createElement(Child, __assign({}, extraProps, {
        visible: visible,
        prefixCls: this.prefixCls,
        onCancel: this.onCancel,
        onEnter: this.onEnter,
        onExited: this.onExited,
        ref: this.childRef
      }), children)));
    }

    return null;
  }; // 默认值


  Drawer.defaultProps = {
    placement: 'left',
    width: '2.45rem',
    height: '2.45rem',
    closable: true,
    showMask: true,
    maskClosable: true,
    hiddenScroll: true,
    keyboard: true
  };
  return Drawer;
}(React.Component);

export default Drawer;