var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import React from 'react';
import classNames from 'classnames';
import { isElement, isFragment } from 'react-is';
var cls = 're-ellipsis';

var getStyle = function getStyle(lines, maxHeight) {
  return {
    WebkitLineClamp: lines,
    maxHeight: maxHeight
  };
};

function Ellipsis(props) {
  var children = props.children,
      maxHeight = props.maxHeight,
      className = props.className,
      _a = props.lines,
      lines = _a === void 0 ? 2 : _a,
      title = props.title;
  var style = getStyle(lines, maxHeight);
  var titleParam = title ? {
    title: title
  } : null; // 当children是单个标签元素时（非文本元素），将直接在该标签上加上style, className，title属性

  if (!isFragment(children) && isElement(children)) {
    var child = children;
    return React.cloneElement(child, __assign(__assign({}, titleParam), {
      className: classNames(cls, className, child.props.className),
      style: __assign(__assign({}, style), child.props.style)
    }));
  }

  return React.createElement("span", __assign({
    className: classNames(cls, className)
  }, titleParam, {
    style: style
  }), children);
}

export default React.memo(Ellipsis);