var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import React from 'react';
import classNames from 'classnames';
import { isBlank } from '../utils/string';
import debounce from '../utils/debounce';
import { getOffset } from '../utils/get';
import addEventListener from '../utils/addEventListener';
var cls = 're-input-number';

var InputNumber =
/** @class */
function (_super) {
  __extends(InputNumber, _super);

  function InputNumber(props) {
    var _this = _super.call(this, props) || this;

    _this.currentRef = React.createRef();

    _this.onFocus = function () {
      if (!_this.props.visibleButton) {
        return;
      }

      _this.setState({
        focus: true
      });
    };

    _this.onBlur = function () {
      if (!_this.props.visibleButton) {
        return;
      }

      _this.setState({
        focus: false
      });
    };

    _this.onMouseEnter = function () {
      if (!_this.props.visibleButton) {
        return;
      }

      _this.setState({
        enter: true
      }, function () {
        _this.getLocationInfo();
      });
    };

    _this.onMouseLeave = function () {
      if (!_this.props.visibleButton) {
        return;
      }

      _this.setState({
        enter: false
      });
    };

    _this.onMouseMove = function (ev) {
      if (!_this.props.visibleButton) {
        return;
      }

      var _a = _this.getElement(),
          inputEl = _a.inputEl,
          addBtnEl = _a.addBtnEl,
          subBtnEl = _a.subBtnEl;

      if (!inputEl || !addBtnEl || !subBtnEl) {
        return;
      }

      var _b = _this.getMouseElement(ev),
          isAdd = _b.isAdd,
          isSub = _b.isSub;

      if (isAdd) {
        inputEl.style.cursor = 'default';
        addBtnEl.setAttribute('class', cls + "-button " + cls + "-hover");
        return;
      }

      if (isSub) {
        inputEl.style.cursor = 'default';
        subBtnEl.setAttribute('class', cls + "-button " + cls + "-hover");
        return;
      }

      inputEl.style.cursor = 'text';
      addBtnEl.setAttribute('class', cls + "-button");
      subBtnEl.setAttribute('class', cls + "-button");
    };

    _this.onMouseDown = function (ev) {
      if (!_this.props.visibleButton) {
        return;
      }

      var _a = _this.getElement(),
          addBtnEl = _a.addBtnEl,
          subBtnEl = _a.subBtnEl;

      if (!addBtnEl || !subBtnEl) {
        return;
      } // 按下时清除move事件


      if (_this.mouseMoveHandler) {
        _this.mouseMoveHandler.remove();

        _this.mouseMoveHandler = null;
      }

      var _b = _this.getMouseElement(ev),
          isAdd = _b.isAdd,
          isSub = _b.isSub;

      if (isAdd) {
        addBtnEl.setAttribute('class', cls + "-button " + cls + "-active");

        _this.onAdd();
      }

      if (isSub) {
        subBtnEl.setAttribute('class', cls + "-button " + cls + "-active");

        _this.onSub();
      }

      _this.addMouseUpListener();
    };

    _this.onMouseUp = function () {
      if (_this.mouseUpHandler) {
        _this.mouseUpHandler.remove();

        _this.mouseUpHandler = null;
      }

      var _a = _this.getElement(),
          addBtnEl = _a.addBtnEl,
          subBtnEl = _a.subBtnEl;

      if (addBtnEl && subBtnEl) {
        addBtnEl.setAttribute('class', cls + "-button");
        subBtnEl.setAttribute('class', cls + "-button");
      } // 重新添加move事件


      _this.addMouseMoveListener();
    };

    _this.addMouseMoveListener = function () {
      var inputEl = _this.getElement().inputEl;

      if (!inputEl) {
        return;
      }

      _this.mouseMoveHandler = addEventListener(inputEl, 'mousemove', _this.onMouseMove);
    };

    _this.addMouseUpListener = function () {
      _this.mouseUpHandler = addEventListener(window.document, 'mouseup', _this.onMouseUp);
    };

    _this.getElement = function () {
      var element = _this.currentRef.current;
      var inputEl;
      var buttonEl;
      var addBtnEl;
      var subBtnEl;

      if (element && element.childNodes.length) {
        inputEl = element.childNodes[0];
      }

      if (element && element.childNodes.length > 1) {
        buttonEl = element.childNodes[1];
        addBtnEl = buttonEl.children[0];
        subBtnEl = buttonEl.children[1];
      }

      return {
        inputEl: inputEl,
        addBtnEl: addBtnEl,
        subBtnEl: subBtnEl
      };
    }; // 判断鼠标是否在按钮位置，在哪个按钮


    _this.getMouseElement = function (ev) {
      var isAdd = _this.isInside(ev, _this.addLocationInfo);

      var isSub = _this.isInside(ev, _this.subLocationInfo);

      return {
        isAdd: isAdd,
        isSub: isSub
      };
    };

    _this.isInside = function (ev, locationInfo) {
      if (!locationInfo) {
        return false;
      }

      var pageX = ev.pageX,
          pageY = ev.pageY;
      var left = locationInfo.left,
          top = locationInfo.top,
          width = locationInfo.width,
          height = locationInfo.height;
      return pageX > left && pageX < left + width && pageY > top && pageY < top + height;
    };

    _this.getLocationInfo = function () {
      var _a = _this.getElement(),
          addBtnEl = _a.addBtnEl,
          subBtnEl = _a.subBtnEl;

      if (!addBtnEl || !subBtnEl) {
        return;
      }

      _this.addLocationInfo = getOffset(addBtnEl);
      _this.subLocationInfo = getOffset(subBtnEl);
    }; // 不需要根据props的value更新


    _this.getCurrentValue = function (value) {
      var _a = _this.props,
          min = _a.min,
          max = _a.max;
      var valueNumber = parseFloat(value);
      var packMultiple = _this.props.packMultiple || 1; // 取大于等于值且是打包个数倍数的值

      var ceilNumber = Math.ceil(valueNumber / packMultiple) * packMultiple; // 当值在临界点和临界点之外时

      if (ceilNumber <= min) {
        return Math.ceil(min / packMultiple) * packMultiple;
      }

      if (ceilNumber >= max) {
        return Math.floor(max / packMultiple) * packMultiple;
      }

      return ceilNumber;
    };

    _this.onChangePackMultipleValue = function (value) {
      var currentValue = _this.getCurrentValue(value).toString();

      var _a = _this.props,
          onChange = _a.onChange,
          onChangePackMultipleAfter = _a.onChangePackMultipleAfter,
          name = _a.name;
      onChange(currentValue, name);

      if (onChangePackMultipleAfter) {
        onChangePackMultipleAfter(currentValue, name);
      }
    };

    _this.getDebounce = function () {
      if (_this.debounce) {
        return _this.debounce;
      }

      _this.debounce = debounce(_this.onChangePackMultipleValue, _this.props.delay);
      return _this.debounce;
    };

    _this.callback = function (value) {
      var _a = _this.props,
          name = _a.name,
          onChange = _a.onChange,
          onChangePackMultipleBefore = _a.onChangePackMultipleBefore;
      var packMultiple = _this.props.packMultiple || 1;

      if (onChange) {
        onChange(value, name);
      }

      var valueNumber = parseFloat(value);

      if (!isBlank(packMultiple) && !isBlank(value) && valueNumber % packMultiple !== 0) {
        if (onChangePackMultipleBefore) {
          onChangePackMultipleBefore(value, name);
        }

        _this.getDebounce()(value);
      }
    };

    _this.onValueChange = function (ev) {
      if (_this.debounce) {
        _this.debounce.cancel();
      }

      var _a = _this.props,
          min = _a.min,
          max = _a.max,
          isPositive = _a.isPositive,
          value = _a.value;
      var currentValue = ev.target.value.toString();

      if (isBlank(currentValue)) {
        _this.callback('');

        return;
      }

      var preValue = value.toString();
      var reg = /^-$|(^(-?\d+)(\.\d*)?)$/;

      if (!reg.test(currentValue)) {
        _this.callback(preValue);

        return;
      } // 0开头后面直接是数字，没有点如：011， 这是不合法的


      var zeroReg = /^0\d+$/;

      if (zeroReg.test(currentValue)) {
        _this.callback(preValue);

        return;
      }

      var valueNumber = parseFloat(currentValue);

      if (!isBlank(min)) {
        if (min > valueNumber) {
          _this.callback(preValue);

          return;
        } // 如果min>= 0, 将阻止输入-


        if (min >= 0 && currentValue.indexOf('-') > -1) {
          _this.callback('');

          return;
        }
      }

      if (!isBlank(max) && max < valueNumber) {
        _this.callback(preValue);

        return;
      }

      if (isPositive && currentValue.indexOf('.') > -1) {
        _this.callback(preValue);

        return;
      }

      _this.callback(currentValue);
    };

    _this.onAdd = function () {
      var _a = _this.props,
          packMultiple = _a.packMultiple,
          value = _a.value;
      var step = packMultiple || 1; // valueNumber 可能为NaN

      var ev = {
        target: {
          value: (parseFloat(value.toString()) || 0) + step
        }
      };

      _this.onValueChange(ev);
    };

    _this.onSub = function () {
      var _a = _this.props,
          packMultiple = _a.packMultiple,
          value = _a.value;
      var step = packMultiple || 1;
      var ev = {
        target: {
          value: (parseFloat(value.toString()) || 0) - step
        }
      };

      _this.onValueChange(ev);
    }; // 渲染加减按钮


    _this.renderButton = function () {
      return React.createElement("div", {
        className: cls + "-button-wrap"
      }, React.createElement("div", {
        className: cls + "-button",
        onClick: _this.onAdd
      }, React.createElement("div", {
        className: cls + "-add"
      })), React.createElement("div", {
        className: cls + "-button",
        onClick: _this.onSub
      }, React.createElement("div", {
        className: cls + "-sub"
      })));
    };

    _this.state = {
      enter: false,
      focus: false
    };
    return _this;
  }

  InputNumber.prototype.componentDidMount = function () {
    this.addMouseMoveListener();
  };

  InputNumber.prototype.componentWillUnmount = function () {
    if (this.mouseUpHandler) {
      this.mouseUpHandler.remove();
      this.mouseUpHandler = null;
    }

    if (this.mouseMoveHandler) {
      this.mouseMoveHandler.remove();
      this.mouseMoveHandler = null;
    }

    if (this.debounce) {
      this.debounce.cancel();
      this.debounce = null;
    }
  };

  InputNumber.prototype.render = function () {
    var copyProps = __assign({}, this.props);

    delete copyProps.onChangePackMultipleBefore;
    delete copyProps.onChangePackMultipleAfter;
    delete copyProps.isPositive;
    delete copyProps.packMultiple;
    delete copyProps.visibleButton;
    delete copyProps.onChange;
    delete copyProps.min;
    delete copyProps.max;
    delete copyProps.delay;

    if (isBlank(copyProps.name)) {
      delete copyProps.name;
    }

    var _a = this.props,
        className = _a.className,
        visibleButton = _a.visibleButton;
    var _b = this.state,
        enter = _b.enter,
        focus = _b.focus;
    var inputStyle = visibleButton ? {
      paddingRight: '.2rem'
    } : {};
    return React.createElement("label", {
      className: cls + "-wrap",
      ref: this.currentRef
    }, React.createElement("input", __assign({}, copyProps, {
      className: classNames(cls, className),
      type: "text",
      onChange: this.onValueChange,
      onMouseDown: this.onMouseDown,
      onFocus: this.onFocus,
      onBlur: this.onBlur,
      onMouseEnter: this.onMouseEnter,
      onMouseLeave: this.onMouseLeave,
      style: inputStyle
    })), visibleButton && (enter || focus) ? this.renderButton() : null);
  };

  InputNumber.defaultProps = {
    value: '',
    name: '',
    size: 3,
    disabled: false,
    isPositive: true,
    delay: 1000,
    visibleButton: false
  };
  return InputNumber;
}(React.Component);

export default InputNumber;