var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import 'intersection-observer';
import React from 'react';
import classNames from 'classnames';

function noop() {}

var LazyImage =
/** @class */
function (_super) {
  __extends(LazyImage, _super);

  function LazyImage(props) {
    var _this = _super.call(this, props) || this;

    _this.prefixCls = 're-lazy-image';
    _this.rootRef = React.createRef();
    _this.isUnmount = false;
    /**
     * 监听原生lazy loading, 并回调不同的事件
     */

    _this.originalLazyLoad = function () {
      if (_this.rootRef.current) {
        var _a = _this.props,
            onLoading = _a.onLoading,
            onLoaded_1 = _a.onLoaded,
            onError_1 = _a.onError;
        var imgElement_1 = _this.rootRef.current;

        if (onLoading) {
          onLoading(imgElement_1.src);
        }

        if (imgElement_1.complete) {
          if (!_this.isUnmount) {
            _this.setState({
              loading: false
            });
          }

          if (onLoaded_1) {
            onLoaded_1(imgElement_1.src);
          }

          return;
        }

        imgElement_1.onload = function () {
          if (!_this.isUnmount) {
            _this.setState({
              loading: false
            });
          }

          if (onLoaded_1) {
            onLoaded_1(imgElement_1.src);
          }

          imgElement_1.onload = null;
        };

        imgElement_1.onerror = function () {
          if (!_this.isUnmount) {
            _this.setState({
              loading: false
            });
          }

          if (onError_1) {
            onError_1();
          }

          imgElement_1.onerror = null;
        };
      }
    };

    _this.onMouseOut = function (ev) {
      if (_this.props.isMobile) {
        return;
      }

      var _a = _this.props,
          hoverOpacity = _a.hoverOpacity,
          onMouseOut = _a.onMouseOut;
      var el = ev.target;

      if (hoverOpacity) {
        el.style.opacity = '1';
      }

      if (onMouseOut) {
        onMouseOut(ev);
      }
    };

    _this.onMouseOver = function (ev) {
      if (_this.props.isMobile) {
        return;
      }

      var _a = _this.props,
          hoverOpacity = _a.hoverOpacity,
          onMouseOver = _a.onMouseOver;
      var el = ev.target;

      if (hoverOpacity) {
        el.style.opacity = hoverOpacity.toString();
      }

      if (onMouseOver) {
        onMouseOver(ev);
      }
    };

    _this.state = {
      loading: true
    };
    return _this;
  }

  LazyImage.prototype.componentWillUnmount = function () {
    this.isUnmount = true;
  };

  LazyImage.prototype.componentDidMount = function () {
    this.originalLazyLoad();
  };

  LazyImage.prototype.componentDidUpdate = function (prevProps) {
    if (prevProps.src !== this.props.src) {
      this.originalLazyLoad();
    }
  };

  LazyImage.prototype.render = function () {
    var _a;

    var cls = this.prefixCls;
    var _b = this.props,
        className = _b.className,
        active = _b.active;
    var loading = this.state.loading;

    var props = __assign({}, this.props);

    delete props.className;
    delete props.onMouseOver;
    delete props.onMouseOut;
    delete props.hoverOpacity;
    delete props.isMobile;
    delete props.active;
    delete props.onLoading;
    delete props.onLoaded;
    return React.createElement("img", __assign({
      alt: ""
    }, props, {
      className: classNames(cls, className, (_a = {}, _a[cls + "-loading"] = loading, _a[cls + "-active"] = loading && active, _a)),
      onMouseOver: this.onMouseOver,
      onMouseOut: this.onMouseOut,
      onFocus: noop,
      onBlur: noop,
      ref: this.rootRef,
      loading: "lazy"
    }));
  };

  LazyImage.defaultProps = {
    className: '',
    hoverOpacity: null,
    isMobile: false,
    active: true
  };
  return LazyImage;
}(React.Component);

export default LazyImage;