var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import React from 'react';
import * as ReactIs from 'react-is';
import classNames from 'classnames';
import addEventListener from '../utils/addEventListener';
import { isTouchScreen, isEmptyObject } from '../utils/string';
import { filterPositionRange, filterScaleRange } from './range';
import { getElementSize } from '../utils/get';
import { getDistance, getInitElementPlacement } from './utils';
import throttleWithRAF from '../utils/throttleWithRAF';
var defaultPosition = {
  left: 0,
  top: 0
};

var Move =
/** @class */
function (_super) {
  __extends(Move, _super);

  function Move() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.prefixCls = 're-move';
    _this.prevElementSize = {
      width: 0,
      height: 0
    };
    _this.elementSize = {
      width: 0,
      height: 0
    };
    _this.elementParentSize = {
      width: 0,
      height: 0
    };
    _this.startObj = __assign({}, defaultPosition);
    _this.prevObj = __assign({}, defaultPosition);
    _this.currentObj = __assign({}, defaultPosition);
    _this.moveObj = __assign({}, defaultPosition);
    _this.prevScaleSize = 1;
    _this.currentScaleSize = 1;
    _this.scaleStart = 0;
    _this.scaleEnd = 0;
    _this.isTouchScale = false; // 强制刷新元素位置

    _this.isForceUpdatePlacement = false;
    _this.moveRef = React.createRef();
    _this.updateTimer = null;

    _this.refreshInfo = function (el, prevProps) {
      var element = el || _this.getDomNode();

      if (!element) {
        return;
      }

      var parentNode = element.parentNode;

      if (!parentNode) {
        return;
      }

      var elementSize = getElementSize(element);
      _this.elementSize = {
        width: elementSize.width,
        height: elementSize.height
      };

      if (_this.elementSize.width !== _this.prevElementSize.width || _this.elementSize.height !== _this.prevElementSize.height) {
        _this.isForceUpdatePlacement = true;
      }

      _this.prevElementSize = _this.elementSize;
      _this.elementParentSize = getElementSize(parentNode, true);
      var _a = _this.props,
          horizontalPlacement = _a.horizontalPlacement,
          verticalPlacement = _a.verticalPlacement;

      if (!prevProps || _this.isForceUpdatePlacement || horizontalPlacement !== prevProps.horizontalPlacement || verticalPlacement !== prevProps.verticalPlacement) {
        _this.currentObj = getInitElementPlacement({
          horizontalPlacement: horizontalPlacement,
          verticalPlacement: verticalPlacement,
          elementSize: _this.elementSize,
          elementParentSize: _this.elementParentSize
        });

        var _b = _this.checkRange(),
            nextScaleSize = _b.nextScaleSize,
            nextX = _b.nextX,
            nextY = _b.nextY;

        _this.currentObj = {
          left: nextX,
          top: nextY
        };
        _this.currentScaleSize = nextScaleSize;

        _this.setElementInfo(element);

        element.style.visibility = 'visible';
        _this.isForceUpdatePlacement = false;
      }
    };

    _this.resetTranslate = function (info) {
      var element = _this.getDomNode();

      if (isEmptyObject(info) || !element) {
        return;
      }

      _this.currentObj = info;
      element.style.transition = 'transform 200ms ease-in-out';

      var _a = _this.checkRange(),
          nextX = _a.nextX,
          nextY = _a.nextY,
          nextScaleSize = _a.nextScaleSize,
          isRefresh = _a.isRefresh;

      if (isRefresh) {
        _this.currentObj = {
          left: nextX,
          top: nextY
        };
        _this.currentScaleSize = nextScaleSize;
      }

      _this.setElementInfo(element);
    };

    _this.onMousewheel = function (event, element) {
      if (event.preventDefault) {
        event.preventDefault();
      }

      if (event.stopPropagation) {
        event.stopPropagation();
      }

      var _a = _this.props,
          maxScalable = _a.maxScalable,
          minScalable = _a.minScalable;
      var nextScaleSize = filterScaleRange(event.deltaY < 0 ? _this.currentScaleSize + 0.02 : _this.currentScaleSize - 0.02, maxScalable, minScalable);

      if (_this.currentScaleSize === nextScaleSize || _this.currentScaleSize === nextScaleSize) {
        return;
      }

      _this.currentScaleSize = nextScaleSize;
      element.style.transition = 'transform 200ms';

      _this.setElementInfo(element);
    };

    _this.onStart = function (event, element) {
      if (event.preventDefault) {
        event.preventDefault();
      }

      if (event.stopPropagation) {
        event.stopPropagation();
      }

      _this.isTouchScale = false;
      element.style.transition = '';
      var isTouch = isTouchScreen();
      _this.prevScaleSize = _this.currentScaleSize;

      if (_this.props.scalable && isTouch && event.touches.length > 1) {
        _this.isTouchScale = true; // 记录双指的间距长度

        _this.scaleStart = getDistance(event.touches);
      } else {
        _this.moveObj = __assign({}, defaultPosition);
        _this.prevObj = __assign({}, _this.currentObj);
        _this.startObj = {
          left: event.touches ? event.touches[0].pageX : event.clientX,
          top: event.touches ? event.touches[0].pageY : event.clientY
        };
      }

      if (!_this.moveHandler) {
        _this.moveHandler = addEventListener(window.document, isTouch ? 'touchmove' : 'mousemove', function (ev) {
          return _this.onMove(ev, element);
        });
      }

      if (!_this.endHandler) {
        _this.endHandler = addEventListener(window.document, isTouch ? 'touchend' : 'mouseup', function (ev) {
          return _this.onEnd(ev, element);
        });
      }
    };

    _this.onMove = function (event, element) {
      if (event.preventDefault) {
        event.preventDefault();
      }

      if (event.stopPropagation) {
        event.stopPropagation();
      }

      if (_this.isTouchScale && event.touches.length > 1) {
        _this.scaleEnd = getDistance(event.touches); // 设置缩放尺寸

        _this.currentScaleSize = (_this.scaleEnd / _this.scaleStart - 1) / 2 + _this.prevScaleSize;

        _this.setElementInfo(element);

        return;
      }

      if (_this.isTouchScale && event.touches.length <= 1) {
        return;
      }

      _this.moveObj = {
        left: event.touches ? event.touches[0].pageX : event.clientX,
        top: event.touches ? event.touches[0].pageY : event.clientY
      };
      _this.currentObj = {
        left: _this.prevObj.left + _this.moveObj.left - _this.startObj.left,
        top: _this.prevObj.top + _this.moveObj.top - _this.startObj.top
      };

      _this.setElementInfo(element);
    };

    _this.onEnd = function (event, element) {
      _this.clearHandler();

      if (event.preventDefault) {
        event.preventDefault();
      }

      if (event.stopPropagation) {
        event.stopPropagation();
      }

      var _a = _this.checkRange(),
          nextX = _a.nextX,
          nextY = _a.nextY,
          nextScaleSize = _a.nextScaleSize,
          isRefresh = _a.isRefresh;

      if (isRefresh) {
        element.style.transition = 'transform 200ms ease-in-out';
        _this.currentObj = {
          left: nextX,
          top: nextY
        };
        _this.currentScaleSize = nextScaleSize;

        _this.setElementInfo(element);
      }

      var onClick = _this.props.onClick;

      if (onClick && _this.currentObj.left === _this.prevObj.left && _this.currentObj.top === _this.prevObj.top && _this.prevScaleSize === _this.currentScaleSize) {
        onClick(event);
      }
    };

    _this.onTransitionEnd = function () {
      var element = _this.getDomNode();

      if (!element) {
        return;
      }

      element.style.transition = '';
      var _a = _this.props,
          onAfterChange = _a.onAfterChange,
          name = _a.name;

      if (onAfterChange) {
        onAfterChange(name);
      }
    };

    return _this;
  }

  Move.prototype.componentDidMount = function () {
    this.isForceUpdatePlacement = true;
    this.componentDidUpdate();
  };

  Move.prototype.componentDidUpdate = function (prevProps) {
    var _this = this;

    clearTimeout(this.updateTimer);
    var element = this.getDomNode();

    if (!element) {
      return;
    }

    var parentNode = element.parentNode;

    if (!parentNode) {
      return;
    }

    parentNode.style.overflow = 'hidden';
    var _a = this.props,
        horizontalPlacement = _a.horizontalPlacement,
        verticalPlacement = _a.verticalPlacement;

    if (prevProps && (horizontalPlacement !== prevProps.horizontalPlacement || verticalPlacement !== prevProps.verticalPlacement)) {
      this.isForceUpdatePlacement = true;
    }

    this.updateTimer = setTimeout(function () {
      var element = _this.getDomNode();

      if (!element) {
        return;
      }

      _this.refreshInfo(element, prevProps);

      var isTouch = isTouchScreen();

      if (!_this.startHandler) {
        var eventType = isTouch ? 'touchstart' : 'mousedown';
        _this.startHandler = addEventListener(element, eventType, function (ev) {
          return _this.onStart(ev, element);
        });
      } // 不支持Touch的设备监听滚动


      if (_this.props.scalable && !isTouch && !_this.mousewheelHandler) {
        _this.mousewheelHandler = addEventListener(element, 'wheel', function (ev) {
          return _this.onMousewheel(ev, element);
        });
      } // 加入 resize 监听


      if (_this.props.monitorWindowResize && !_this.resizeHandler) {
        _this.resizeHandler = addEventListener(window, 'resize', throttleWithRAF(function () {
          return _this.refreshInfo(element, prevProps);
        }));
      }
    }, 0);
    this.clearHandler();
  };

  Move.prototype.componentWillUnmount = function () {
    clearTimeout(this.updateTimer);

    if (this.startHandler) {
      this.startHandler.remove();
      this.startHandler = null;
    }

    if (this.mousewheelHandler) {
      this.mousewheelHandler.remove();
      this.mousewheelHandler = null;
    }

    if (this.resizeHandler) {
      this.resizeHandler.remove();
      this.resizeHandler = null;
    }

    this.clearHandler();
  };

  Move.prototype.clearHandler = function () {
    if (this.moveHandler) {
      this.moveHandler.remove();
      this.moveHandler = null;
    }

    if (this.endHandler) {
      this.endHandler.remove();
      this.endHandler = null;
    }
  };

  Move.prototype.checkRange = function () {
    var nextScaleSize = this.currentScaleSize;

    if (this.props.scalable) {
      nextScaleSize = filterScaleRange(nextScaleSize, this.props.maxScalable, this.props.minScalable);
    }

    var _a = filterPositionRange(this.currentObj, this.elementSize, this.elementParentSize, nextScaleSize),
        left = _a.left,
        top = _a.top;

    return {
      isRefresh: left !== this.currentObj.left || top !== this.currentObj.top || nextScaleSize !== this.currentScaleSize,
      nextX: left,
      nextY: top,
      nextScaleSize: nextScaleSize
    };
  };

  Move.prototype.setElementInfo = function (element) {
    element.style.transform = "translate(" + this.currentObj.left + "px, " + this.currentObj.top + "px) scale(" + this.currentScaleSize + ")";
  };

  Move.prototype.getDomNode = function () {
    if (this.moveRef && this.moveRef.current) {
      return this.moveRef.current;
    }

    return null;
  };

  Move.prototype.render = function () {
    var children = this.props.children;
    var child = React.Children.only(children);

    if (ReactIs.isElement(child) && !ReactIs.isFragment(child)) {
      return React.cloneElement(child, {
        ref: this.moveRef,
        onTransitionEnd: this.onTransitionEnd,
        className: classNames(this.prefixCls, child.props.className)
      });
    }

    throw new Error('Move component only support HTMLElement!');
  };

  Move.defaultProps = {
    scalable: true,
    monitorWindowResize: true,
    minScalable: 1,
    maxScalable: 1,
    horizontalPlacement: 'left',
    verticalPlacement: 'top'
  };
  return Move;
}(React.Component);

export default Move;