function getPositionValue(pValue, cValue, prevValue, scaleSize) {
  var cScaleValue = cValue * scaleSize; // 内容缩放后扩展的一半

  var scaleOverValue = (cScaleValue - cValue) / 2; // 内容小于或等于父级时，滑动不能超出

  if (pValue >= cScaleValue) {
    // 不能超出左边/上边
    if (prevValue < scaleOverValue) {
      return scaleOverValue;
    }

    if (prevValue + cScaleValue - scaleOverValue > pValue) {
      // 不能超出右边/下边
      return pValue - cScaleValue + scaleOverValue;
    }
  } // 内容大于父级时，
  // 滑动时，左边/上边只能滑动到内容最左边/上边， 右边/下边可以滑动到内容最右边/下边


  if (pValue < cScaleValue) {
    // 左边只能滑动到内容最左边/上边
    if (prevValue > scaleOverValue) {
      return scaleOverValue;
    }

    if (Math.abs(prevValue) + pValue + scaleOverValue > cScaleValue) {
      // 右边可以滑动到内容最右边/下边
      return pValue - cScaleValue + scaleOverValue;
    }
  }

  return prevValue;
}

export function filterPositionRange(positionInfo, cSize, pSize, scaleSize) {
  return {
    left: getPositionValue(pSize.width, cSize.width, positionInfo.left, scaleSize),
    top: getPositionValue(pSize.height, cSize.height, positionInfo.top, scaleSize)
  };
}
export function filterScaleRange(nextScaleSize, maxScalable, minScalable) {
  if (nextScaleSize > maxScalable) {
    nextScaleSize = maxScalable;
  } else if (nextScaleSize < minScalable) {
    nextScaleSize = minScalable;
  }

  return nextScaleSize;
}