export function getDistance(touches) {
  var start = {
    left: touches[0].pageX,
    top: touches[0].pageY
  };
  var end = {
    left: touches[1].pageX,
    top: touches[1].pageY
  };
  return Math.sqrt(Math.pow(end.left - start.left, 2) + Math.pow(end.top - start.top, 2));
}
export function getInitElementPlacement(_a) {
  var elementSize = _a.elementSize,
      elementParentSize = _a.elementParentSize,
      horizontalPlacement = _a.horizontalPlacement,
      verticalPlacement = _a.verticalPlacement;
  var translateX = 0;
  var translateY = 0;

  switch (horizontalPlacement) {
    case 'center':
      translateX = (elementParentSize.width - elementSize.width) / 2;
      break;

    case 'right':
      translateX = elementParentSize.width - elementSize.width;
      break;

    default:
      translateX = 0;
  }

  switch (verticalPlacement) {
    case 'center':
      translateY = (elementParentSize.height - elementSize.height) / 2;
      break;

    case 'bottom':
      translateY = elementParentSize.height - elementSize.height;
      break;

    default:
      translateY = 0;
  }

  return {
    left: translateX,
    top: translateY
  };
}