var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import React from 'react';
import classNames from 'classnames';
import Trigger from '../trigger';
var prefixCls = 're-popover';

function Popover(props) {
  var _a;

  var triggerEl = React.useRef(null);

  var _b = React.useState({}),
      arrowStyle = _b[0],
      setState = _b[1];

  var cls = props.prefixCls || prefixCls;

  var onHidePopup = function onHidePopup() {
    if (triggerEl.current && triggerEl.current.hidePopup) {
      triggerEl.current.hidePopup();
    }
  };

  var onArrowStyleChange = function onArrowStyleChange(value) {
    setState(value);
  };

  var hiddenClose = props.hiddenClose,
      closeIcon = props.closeIcon,
      closeClassName = props.closeClassName,
      innerClassName = props.innerClassName,
      tip = props.tip,
      arrowClassName = props.arrowClassName;

  function renderClose() {
    if (hiddenClose) {
      return null;
    } // 当有自定义的icon时，直接使用,样式需要完全自定义


    if (closeIcon) {
      return React.cloneElement(closeIcon, {
        onClick: onHidePopup
      });
    }

    return React.createElement("i", {
      className: classNames(cls + "-close", closeClassName),
      onClick: onHidePopup
    }, "\xD7");
  }

  var innerClass = classNames(cls + "-inner", innerClassName, (_a = {}, _a[cls + "-inner-expand"] = !hiddenClose, _a));

  function renderPopup() {
    return React.createElement(React.Fragment, null, renderClose(), React.createElement("i", {
      className: classNames(cls + "-arrow", arrowClassName),
      style: arrowStyle
    }), React.createElement("div", {
      className: innerClass
    }, tip));
  }

  return React.createElement(Trigger, __assign({}, props, {
    wrapClassName: classNames(cls + "-wrap ", props.wrapClassName),
    ref: triggerEl,
    hiddenArrow: false,
    popup: renderPopup,
    onArrowStyleChange: onArrowStyleChange
  }), props.children);
}

Popover.defaultProps = {
  hiddenClose: true
};
export default Popover;