var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import React, { Component } from 'react';
import classNames from 'classnames';
import { isBlank } from '../utils/string';
import { getStyleValue, getStyle } from '../utils/get';

var ShowMore =
/** @class */
function (_super) {
  __extends(ShowMore, _super);

  function ShowMore(props) {
    var _this = _super.call(this, props) || this;

    _this.prefixCls = 're-show-more';

    _this.setTargetElement = function (el) {
      return _this.targetElement = el;
    };

    _this.setChildrenElement = function (el) {
      return _this.textElement = el;
    };

    _this.setHiddenTextStatus = function () {
      _this.calcTargetWidth(function () {
        if (_this.textElement) {
          _this.setState({
            hiddenTextElement: true
          }, _this.props.onAfterMounted);
        }
      });
    };

    _this.onChange = function () {
      if (!_this.props.expandable) {
        return;
      }

      _this.setRenderText(_this.props.onAfterChange, false);
    };

    _this.innerText = function (node) {
      var div = document.createElement('div');
      var contentKey = 'innerText' in window.HTMLElement.prototype ? 'innerText' : 'textContent';
      div.innerHTML = node.innerHTML.replace(/\r\n|\r|\n/g, ' ');
      var text = div[contentKey];
      var test = document.createElement('div');
      test.innerHTML = 'foo<br/>bar';

      if (test[contentKey].replace(/\r\n|\r/g, '\n') !== 'foo\nbar') {
        div.innerHTML = div.innerHTML.replace(/<br.*?[\/]?>/gi, '\n');
        text = div[contentKey];
      }

      return text;
    };

    _this.calcTargetWidth = function (callback) {
      var targetElement = _this.targetElement;

      if (!targetElement) {
        return;
      } // 需要减去padding值


      var parentNode = targetElement.parentNode;
      var clientWidth = parentNode.clientWidth;
      var contentPaddingLeft = getStyleValue(parentNode, 'padding-left');
      var contentPaddingRight = getStyleValue(parentNode, 'padding-right');
      _this.targetWidth = _this.props.width || clientWidth - contentPaddingLeft - contentPaddingRight;
      var style = getStyle(targetElement); // todo: font-weight放首位在ie下失效

      _this.canvasContext.font = [style['font-style'], style['font-weight'], style['font-size'], style['font-family']].join(' ');

      _this.setRenderText(callback);
    };

    _this.measureWidth = function (text) {
      try {
        return _this.canvasContext.measureText(text).width;
      } catch (e) {
        return 0;
      }
    };

    _this.getLines = function (targetWidth) {
      var _a;

      var _b = _this,
          _c = _b.props,
          numLines = _c.lines,
          ellipsisText = _c.ellipsisText,
          expandable = _c.expandable,
          innerText = _b.innerText,
          measureWidth = _b.measureWidth,
          cls = _b.prefixCls;
      var ellipsisClassName = _this.props.ellipsisClassName;
      var lines = []; // children没显示，无法计算

      if (!_this.textElement) {
        return {
          lines: lines,
          hiddenLineStr: ''
        };
      }

      var text = innerText(_this.textElement);
      var hiddenLineStr = text; // 先按换行符拆分，再按空格拆分成组

      var textLines = text.split('\n').map(function (line) {
        return line.split(' ');
      }); // 省略号和按钮的宽度

      var ellipsisWidth = measureWidth(ellipsisText) + measureWidth('... ');

      for (var line = 1; line <= numLines; line++) {
        var textWords = textLines[0]; // 一行中单词显示完了，转到第二行

        if (textWords.length === 0) {
          lines.push();
          textLines.shift();
          line--;
          continue;
        }

        var resultLine = textWords.join(' ');

        if (measureWidth(resultLine) <= targetWidth) {
          if (textLines.length === 1) {
            lines.push(resultLine);
            hiddenLineStr = '';
            break;
          }
        } // 最后一行时，要加上ellipsisWidth


        if (line === numLines) {
          var textRest = textWords.join(' ');
          var lower = 0;
          var upper = textRest.length - 1;

          while (lower <= upper) {
            var middle = Math.floor((lower + upper) / 2);
            var testLine = textRest.slice(0, middle + 1);

            if (measureWidth(testLine) + ellipsisWidth <= targetWidth) {
              lower = middle + 1;
            } else {
              upper = middle - 1;
            }
          }

          var lastLineText = textRest.slice(0, lower);
          hiddenLineStr = hiddenLineStr.replace(lastLineText, '');
          resultLine = React.createElement(React.Fragment, null, lastLineText + "... ", React.createElement("span", {
            className: classNames(ellipsisClassName, cls + "-ellipsis", (_a = {}, _a[cls + "-btn"] = expandable, _a)),
            onClick: _this.onChange
          }, ellipsisText));
        } else {
          var lower = 0;
          var upper = textWords.length - 1;

          while (lower <= upper) {
            var middle = Math.floor((lower + upper) / 2);
            var testLine = textWords.slice(0, middle + 1).join(' ');

            if (measureWidth(testLine) <= targetWidth) {
              lower = middle + 1;
            } else {
              upper = middle - 1;
            }
          } // 单词太长，只显示最后一行


          if (lower === 0) {
            line = numLines - 1;
            continue;
          }

          resultLine = textWords.slice(0, lower).join(' ');
          hiddenLineStr = hiddenLineStr.replace(resultLine, '');
          textLines[0].splice(0, lower);
        }

        lines.push(resultLine);
      }

      return {
        lines: lines,
        hiddenLineStr: hiddenLineStr
      };
    };

    _this.renderLine = function (line, i, arr) {
      if (i === arr.length - 1) {
        return React.createElement(React.Fragment, {
          key: i
        }, line);
      }

      var br = React.createElement("br", {
        key: i + "br"
      });

      if (line) {
        return [React.createElement(React.Fragment, {
          key: i
        }, line), br];
      }

      return br;
    };

    _this.setRenderText = function (callback, isHidden) {
      var targetWidth = _this.targetWidth;
      var _a = _this.props,
          children = _a.children,
          numLines = _a.lines;
      var previewText;
      var hiddenText;
      var isTruncated = isBlank(isHidden) ? _this.state.isTruncated : isHidden;

      if (numLines > 0 && isTruncated && targetWidth) {
        var _b = _this.getLines(targetWidth),
            lines = _b.lines,
            hiddenLineStr = _b.hiddenLineStr;

        previewText = lines.map(_this.renderLine);
        hiddenText = hiddenLineStr;
      } else {
        previewText = children;
        hiddenText = '';
      }

      _this.setState({
        previewText: previewText,
        hiddenText: hiddenText,
        isTruncated: isTruncated
      }, callback);
    };

    _this.state = {
      isTruncated: true,
      hiddenTextElement: false,
      previewText: '',
      hiddenText: ''
    };
    return _this;
  }

  ShowMore.prototype.componentDidMount = function () {
    var canvas = document.createElement('canvas');
    this.canvasContext = canvas.getContext('2d');
    this.delayCalculate();
  };

  ShowMore.prototype.componentDidUpdate = function (prevProps) {
    if (this.props.children !== prevProps.children || this.props.width !== prevProps.width) {
      // 执行render，并且跳过shouldComponentUpdate
      this.delayCalculate();
    }
  };

  ShowMore.prototype.componentWillUnmount = function () {
    if (this.timer) {
      clearTimeout(this.timer);
    }
  }; // 等页面其他元素加载完成，延迟计算宽度


  ShowMore.prototype.delayCalculate = function () {
    var _this = this;

    if (this.timer) {
      clearTimeout(this.timer);
    } // children显示的时候, DidMount


    if (!this.state.hiddenTextElement) {
      this.timer = setTimeout(this.setHiddenTextStatus);
      return;
    } // children隐藏的时候, DidUpdate


    this.timer = setTimeout(function () {
      _this.setState({
        hiddenTextElement: false
      }, _this.setHiddenTextStatus);
    });
  };

  ShowMore.prototype.render = function () {
    var _a = this.state,
        hiddenTextElement = _a.hiddenTextElement,
        previewText = _a.previewText,
        hiddenText = _a.hiddenText;
    var _b = this.props,
        children = _b.children,
        className = _b.className,
        title = _b.title;
    var titleParam = title ? {
      title: title
    } : null;
    var cls = this.prefixCls;
    return React.createElement(React.Fragment, null, React.createElement("span", __assign({
      ref: this.setTargetElement,
      className: classNames(cls, className)
    }, titleParam), previewText, hiddenText ? React.createElement("span", {
      className: cls + "-hidden"
    }, hiddenText) : null), hiddenTextElement ? null : React.createElement("span", {
      ref: this.setChildrenElement,
      className: cls + "-text"
    }, children));
  };

  ShowMore.defaultProps = {
    children: '',
    ellipsisText: 'Show More',
    lines: 2,
    width: 0,
    expandable: true
  };
  return ShowMore;
}(Component);

export default ShowMore;