var __spreadArrays = this && this.__spreadArrays || function () {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++) {
    s += arguments[i].length;
  }

  for (var r = Array(s), k = 0, i = 0; i < il; i++) {
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++) {
      r[k] = a[j];
    }
  }

  return r;
};

import React from 'react';
import classNames from 'classnames';
import Item from './Item';
var cls = 're-skeleton';

var Skeleton = function Skeleton(props) {
  var _a;

  var children = props.children,
      content = props.content,
      loading = props.loading,
      active = props.active,
      rows = props.rows,
      className = props.className;

  if (loading) {
    return React.createElement("div", {
      className: classNames(cls, className, (_a = {}, _a[cls + "-active"] = active, _a))
    }, __spreadArrays(Array(rows)).map(function (_item, index) {
      return React.createElement(React.Fragment, {
        key: index
      }, content);
    }));
  }

  return React.createElement(React.Fragment, null, children);
};

Skeleton.Item = Item;
Skeleton.defaultProps = {
  active: true,
  rows: 1
};
export default Skeleton;