export interface Size {
    width: number;
    height: number;
}
interface ElementInfo extends Size {
    left: number;
    top: number;
    offsetLeft?: number;
    offsetTop?: number;
}
interface Params {
    rootInfo: ElementInfo;
    popInfo: ElementInfo;
    translateX: number;
    translateY: number;
    rootToPopupSpacing: number;
    hiddenArrow: boolean;
    isTransformHorizontalDirection: boolean;
    scrollTop: number;
    scrollLeft: number;
    isInsertNode?: boolean;
}
export interface ResultProps extends ElementInfo {
    transformOrigin: string;
    rootWidth: number;
    maxWidth?: number;
    arrowStyle: {
        transform?: string;
        left?: string;
        top?: string;
        right?: string;
        bottom?: string;
    };
}
export declare function getAvailSize(ignoreScroll?: boolean): Size;
export declare function getLeftLocationInfo({ rootInfo, popInfo, translateY, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getRightLocationInfo({ rootInfo, popInfo, translateY, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getTopLocationInfo({ rootInfo, popInfo, translateX, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getBottomLocationInfo({ rootInfo, popInfo, translateX, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getLeftTopLocationInfo({ rootInfo, popInfo, translateY, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getLeftBottomLocationInfo({ rootInfo, popInfo, translateY, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getRightTopLocationInfo({ rootInfo, popInfo, translateY, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getRightBottomLocationInfo({ rootInfo, popInfo, translateY, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getTopLeftLocationInfo({ rootInfo, popInfo, translateX, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getTopRightLocationInfo({ rootInfo, popInfo, translateX, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getBottomLeftLocationInfo({ rootInfo, popInfo, translateX, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export declare function getBottomRightLocationInfo({ rootInfo, popInfo, translateX, rootToPopupSpacing, isTransformHorizontalDirection, hiddenArrow, scrollTop, scrollLeft, isInsertNode }: Params): ResultProps;
export {};
