import _typeof from "@babel/runtime/helpers/esm/typeof";
import ReactDOM from 'react-dom';

function addDOMEventListener(target, eventType, callback, option) {
  if (target && target.addEventListener) {
    var useCapture_1 = false;

    if (_typeof(option) === 'object') {
      useCapture_1 = option.capture || false;
    } else if (typeof option === 'boolean') {
      useCapture_1 = option;
    }

    target.addEventListener(eventType, callback, option || false);
    return {
      remove: function remove() {
        target.removeEventListener(eventType, callback, useCapture_1);
      }
    };
  }

  return null;
}

export default function addEventListener(target, eventType, cb, option) {
  // setState 强制批量处理
  var callback = ReactDOM.unstable_batchedUpdates ? function run(e) {
    ReactDOM.unstable_batchedUpdates(cb, e);
  } : cb;
  return addDOMEventListener(target, eventType, callback, option);
}