/**
 * 防抖
 * @param fn
 * @param delay
 * @param isImmediately 是否立即执行一次
 */
export default function (fn, delay, isImmediately) {
  if (delay === void 0) {
    delay = 250;
  }

  if (isImmediately === void 0) {
    isImmediately = false;
  }

  var timer;

  var debounce = function debounce() {
    var arg = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      arg[_i] = arguments[_i];
    }

    if (timer) {
      clearTimeout(timer);
    }

    if (isImmediately) {
      if (!timer) {
        fn.apply(void 0, arg);
      }

      timer = setTimeout(function () {
        timer = null;
      }, delay);
    } else {
      timer = setTimeout(function () {
        fn.apply(void 0, arg);
      }, delay);
    }
  };

  debounce.cancel = function () {
    clearTimeout(timer);
    timer = null;
  };

  return debounce;
}