import Config from './Config';
import getAbortInfo from './abort';
import merge from './merge';
export default function filterUrlAndOptions(url, options, methodOptions) {
  var fetchOptions = merge(Config.fetchOptions, options, methodOptions);
  var baseUrl = fetchOptions.baseUrl || Config.baseUrl;
  delete fetchOptions.baseUrl;
  var requestUse = fetchOptions.requestUse || Config.requestUse;
  delete fetchOptions.requestUse;
  var responseUse = fetchOptions.responseUse || Config.responseUse;
  delete fetchOptions.responseUse;
  var retryCount = fetchOptions.retryCount || Config.retryCount;
  delete fetchOptions.retryCount;
  var retryCondition = fetchOptions.retryCondition || Config.retryCondition;
  delete fetchOptions.retryCondition;
  var setCacheInfo = fetchOptions.setCacheInfo;
  delete fetchOptions.setCacheInfo;
  var cacheNamespace = fetchOptions.cacheNamespace || Config.cacheNamespace;
  delete fetchOptions.cacheNamespace;
  var cacheMethod = fetchOptions.cacheMethod || Config.cacheMethod;
  delete fetchOptions.cacheMethod;
  var beforeRequest = fetchOptions.beforeRequest;
  delete fetchOptions.beforeRequest;
  var afterResponse = fetchOptions.afterResponse;
  delete fetchOptions.afterResponse;
  var abortController;

  if (fetchOptions.cancelable) {
    delete fetchOptions.cancelable;

    var _a = getAbortInfo(),
        controller = _a.controller,
        signal = _a.signal;

    if (signal) {
      fetchOptions.signal = signal;
      abortController = controller;
    }
  }

  return {
    allUrl: "" + baseUrl + url,
    requestUse: requestUse,
    responseUse: responseUse,
    beforeRequest: beforeRequest,
    afterResponse: afterResponse,
    fetchOptions: fetchOptions,
    abortController: abortController,
    retryCount: retryCount,
    retryCondition: retryCondition,
    setCacheInfo: setCacheInfo,
    cacheNamespace: cacheNamespace,
    cacheMethod: cacheMethod
  };
}