var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
    label: 0,
    sent: function sent() {
      if (t[0] & 1) throw t[1];
      return t[1];
    },
    trys: [],
    ops: []
  },
      f,
      y,
      t,
      g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;

  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }

  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");

    while (_) {
      try {
        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
        if (y = 0, t) op = [op[0] & 2, t.value];

        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;

          case 4:
            _.label++;
            return {
              value: op[1],
              done: false
            };

          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;

          case 7:
            op = _.ops.pop();

            _.trys.pop();

            continue;

          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }

            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }

            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }

            if (t && _.label < t[2]) {
              _.label = t[2];

              _.ops.push(op);

              break;
            }

            if (t[2]) _.ops.pop();

            _.trys.pop();

            continue;
        }

        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f = t = 0;
      }
    }

    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};

var __spreadArrays = this && this.__spreadArrays || function () {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++) {
    s += arguments[i].length;
  }

  for (var r = Array(s), k = 0, i = 0; i < il; i++) {
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++) {
      r[k] = a[j];
    }
  }

  return r;
};

import md5 from 'md5';
import xhrAdapter from './xhrAdapter';
import { isArray, isBlank, isObject } from '../string';
/**
 * 把key转成string类型
 * @param prevCacheKey
 */

function resetCacheKey(prevCacheKey) {
  if (isArray(prevCacheKey) && prevCacheKey.length) {
    // copy 数据， 防止引用问题
    var cloneCacheKey = __spreadArrays(prevCacheKey);

    var lastValue = cloneCacheKey[prevCacheKey.length - 1];
    cloneCacheKey[prevCacheKey.length - 1] = md5(lastValue);
    return cloneCacheKey.join(':');
  }

  return md5(prevCacheKey);
}

function responseInterceptor(isSuccess, response, options, url, extraInfo) {
  return __awaiter(this, void 0, void 0, function () {
    var filterResponse;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          if (typeof extraInfo.responseUse !== 'function') {
            return [2
            /*return*/
            , response];
          }

          return [4
          /*yield*/
          , extraInfo.responseUse(isSuccess, response, options, url, {
            retryCount: extraInfo.retryCount,
            startTime: extraInfo.startTime
          })];

        case 1:
          filterResponse = _a.sent();

          if (typeof extraInfo.afterResponse !== 'function') {
            return [2
            /*return*/
            , filterResponse];
          }

          return [4
          /*yield*/
          , extraInfo.afterResponse(isSuccess, filterResponse, options, url, {
            retryCount: extraInfo.retryCount,
            startTime: extraInfo.startTime
          })];

        case 2:
          return [2
          /*return*/
          , _a.sent()];
      }
    });
  });
}

export default function interceptor(url, options, otherOptions) {
  return __awaiter(this, void 0, void 0, function () {
    var fetchOptions, fetchOptions, startTime, cacheInfo, cacheResponse, e_1;

    var _this = this;

    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          if (!(typeof otherOptions.requestUse === 'function')) return [3
          /*break*/
          , 2];
          return [4
          /*yield*/
          , otherOptions.requestUse(options, otherOptions.surplusParams, otherOptions.abortController)];

        case 1:
          fetchOptions = _a.sent(); // requestUse 拦截没有返回值，表示ajax 不再执行

          if (!fetchOptions) {
            return [2
            /*return*/
            , Promise.reject({})];
          }

          _a.label = 2;

        case 2:
          if (!(typeof otherOptions.beforeRequest === 'function')) return [3
          /*break*/
          , 4];
          return [4
          /*yield*/
          , otherOptions.beforeRequest(options, otherOptions.surplusParams, otherOptions.abortController)];

        case 3:
          fetchOptions = _a.sent(); // beforeRequest 拦截没有返回值，表示ajax 不再执行

          if (!fetchOptions) {
            return [2
            /*return*/
            , Promise.reject({})];
          }

          _a.label = 4;

        case 4:
          startTime = Date.now();
          cacheInfo = {};
          if (!(typeof otherOptions.setCacheInfo === 'function' && otherOptions.cacheMethod)) return [3
          /*break*/
          , 10];
          cacheInfo = otherOptions.setCacheInfo(url, options, otherOptions.surplusParams);
          if (!cacheInfo.isCache) return [3
          /*break*/
          , 10];
          _a.label = 5;

        case 5:
          _a.trys.push([5, 9,, 10]);

          return [4
          /*yield*/
          , otherOptions.cacheMethod.getData(resetCacheKey(cacheInfo.cacheKey), otherOptions.cacheNamespace)];

        case 6:
          cacheResponse = _a.sent();
          if (!cacheResponse) return [3
          /*break*/
          , 8];
          return [4
          /*yield*/
          , responseInterceptor(true, cacheResponse, options, url, {
            responseUse: otherOptions.responseUse,
            afterResponse: otherOptions.afterResponse,
            startTime: startTime
          })];

        case 7:
          return [2
          /*return*/
          , _a.sent()];

        case 8:
          return [3
          /*break*/
          , 10];

        case 9:
          e_1 = _a.sent();
          return [3
          /*break*/
          , 10];

        case 10:
          // eslint-disable-next-line consistent-return
          return [2
          /*return*/
          , xhrAdapter(url, options).then(function (response) {
            return __awaiter(_this, void 0, void 0, function () {
              var info, e_2;
              return __generator(this, function (_a) {
                switch (_a.label) {
                  case 0:
                    return [4
                    /*yield*/
                    , responseInterceptor(true, response, options, url, {
                      responseUse: otherOptions.responseUse,
                      afterResponse: otherOptions.afterResponse,
                      startTime: startTime
                    })];

                  case 1:
                    info = _a.sent();
                    _a.label = 2;

                  case 2:
                    _a.trys.push([2, 5,, 6]);

                    if (!(cacheInfo.isCache && response && response.data && response.status === 200 && response.data.code === 200)) return [3
                    /*break*/
                    , 4];
                    return [4
                    /*yield*/
                    , otherOptions.cacheMethod.setData(resetCacheKey(cacheInfo.cacheKey), otherOptions.cacheNamespace, response)];

                  case 3:
                    _a.sent();

                    _a.label = 4;

                  case 4:
                    return [3
                    /*break*/
                    , 6];

                  case 5:
                    e_2 = _a.sent();
                    return [3
                    /*break*/
                    , 6];

                  case 6:
                    return [2
                    /*return*/
                    , info];
                }
              });
            });
          }).catch(function (error) {
            return __awaiter(_this, void 0, void 0, function () {
              var response, info;
              return __generator(this, function (_a) {
                switch (_a.label) {
                  case 0:
                    response = isObject(error) ? error : {
                      catchError: error.toString()
                    };
                    return [4
                    /*yield*/
                    , responseInterceptor(false, response, options, url, {
                      responseUse: otherOptions.responseUse,
                      afterResponse: otherOptions.afterResponse,
                      retryCount: otherOptions.retryCount,
                      startTime: startTime
                    })];

                  case 1:
                    info = _a.sent();

                    if (isBlank(otherOptions.retryCount) || otherOptions.retryCount <= 1 || !otherOptions.retryCondition || typeof otherOptions.retryCondition !== 'function' || !otherOptions.retryCondition(error)) {
                      return [2
                      /*return*/
                      , info];
                    }

                    otherOptions.retryCount -= 1;
                    return [4
                    /*yield*/
                    , interceptor(url, options, otherOptions)];

                  case 2:
                    return [2
                    /*return*/
                    , _a.sent()];
                }
              });
            });
          })];
      }
    });
  });
}