var getId = function getId() {
  return "" + new Date().getTime() + Math.random() * 100;
};

var Queue =
/** @class */
function () {
  function Queue() {
    this.cacheInfo = [];
    this.cacheInfo = [];
  }

  Queue.prototype.add = function (level, data, label) {
    var id = getId();
    this.cacheInfo.push({
      id: id,
      level: level,
      data: data,
      label: label
    });
    return id;
  };

  Queue.prototype.update = function (id, level, data, label) {
    var list = this.cacheInfo;
    var findIndex = list.findIndex(function (item) {
      return item.id === id;
    });

    if (findIndex < 0) {
      return this.add(level, data, label);
    }

    this.cacheInfo.splice(findIndex, 1, {
      id: id,
      level: level,
      data: data,
      label: label
    });
    return id;
  };

  Queue.prototype.getAll = function () {
    var result = this.cacheInfo.map(function (item) {
      return {
        level: item.level,
        data: item.data,
        label: item.label
      };
    });
    return JSON.stringify(result);
  };

  Queue.prototype.removeAll = function () {
    this.cacheInfo = [];
  };

  Queue.prototype.has = function (limitCount) {
    if (limitCount) {
      return this.cacheInfo.length >= limitCount;
    }

    return this.cacheInfo.length > 0;
  };

  return Queue;
}();

export default Queue;