import { getStyleValue } from './get';
import { getScrollBarSize } from './getScrollBarSize';
export function isBlank(val) {
  return isUndef(val) || val === '' || val.toString().trim() === '';
}
export function isAllBlank() {
  var args = [];

  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }

  return args.every(function (arg) {
    return isBlank(arg);
  });
}
export function isAllFull() {
  var args = [];

  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }

  return args.every(function (arg) {
    return !isBlank(arg);
  });
}
export function isUndef(val) {
  return val === null || typeof val === 'undefined';
}
export function isEmptyObject(obj) {
  return !obj || Object.keys(obj).length <= 0;
}
var objToString = Object.prototype.toString;
export function isObject(obj) {
  return objToString.call(obj) === '[object Object]';
}
export function isArray(obj) {
  return objToString.call(obj) === '[object Array]';
}
export function isDate(value) {
  return Object.prototype.toString.call(value) === '[object Date]';
}
export function isEmptyArray(obj) {
  return !isArray(obj) || obj.length <= 0;
}
export function hasHorizontalScrollbar(prevScrollSize) {
  var paddingBottom = getStyleValue(window.document.body, 'paddingBottom');
  var scrollSize = prevScrollSize || getScrollBarSize();
  return paddingBottom !== 0 && paddingBottom === scrollSize || document.body.scrollWidth > (window.innerWidth || document.documentElement.clientWidth);
}
export function hasVerticalScrollbar(prevScrollSize) {
  var paddingRight = getStyleValue(window.document.body, 'paddingRight');
  var scrollSize = prevScrollSize || getScrollBarSize();
  return paddingRight !== 0 && paddingRight === scrollSize || document.body.scrollHeight > (window.innerHeight || document.documentElement.clientHeight);
}
export function hasScrollbar(prevScrollSize) {
  var scrollSize = prevScrollSize || getScrollBarSize();
  return hasVerticalScrollbar(scrollSize) || hasHorizontalScrollbar(scrollSize);
}
export var canUseDOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);
export function isTouchScreen() {
  return canUseDOM && 'ontouchstart' in document.documentElement;
}