import { canUseDOM } from './string';
var requestAnimationFrame = canUseDOM ? window.requestAnimationFrame || window.webkitRequestAnimationFrame : function () {};
export default function throttleWithRAF(fn) {
  var ticking = false;
  var callback;

  var update = function update() {
    var arg = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      arg[_i] = arguments[_i];
    }

    fn.apply(void 0, arg);
    ticking = false;
  };

  return function () {
    var arg = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      arg[_i] = arguments[_i];
    }

    if (!ticking) {
      callback = callback || function () {
        return update.apply(void 0, arg);
      };

      requestAnimationFrame(callback);
    }

    ticking = true;
  };
}