import React from 'react';
import { BaseAccordionItemProps } from './Item';
export interface AccordionProps {
    children: React.ReactElement | React.ReactElement[];
    className?: string;
    interactive?: boolean;
    beforeVisibleChange?: (name?: React.ReactText) => boolean;
    onVisibleChange?: (name?: React.ReactText, visible?: boolean) => void;
    defaultVisibleNames?: React.ReactText[];
}
export interface AccordionState {
    visibleNames: {
        [propName: string]: boolean;
        [propName: number]: boolean;
    };
}
export default class Accordion extends React.Component<AccordionProps, AccordionState> {
    readonly prefixCls = "re-accordion";
    static Item: React.ComponentType<BaseAccordionItemProps>;
    constructor(props: any);
    static defaultProps: {
        className: string;
        interactive: boolean;
        defaultVisibleNames: any[];
    };
    /** *
     * 展开下拉链接列表
     * @param name
     */
    onVisibleChange: (name: React.ReactText) => void;
    render(): JSX.Element;
}
