"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactTransitionGroup = require("react-transition-group");

var _portal = _interopRequireDefault(require("../portal"));

function PortalAffix(_a, ref) {
  var cls = _a.prefixCls,
      visible = _a.visible,
      children = _a.children,
      top = _a.top,
      left = _a.left,
      width = _a.width,
      className = _a.className,
      fadeEffect = _a.fadeEffect;
  var style = {
    top: top,
    left: left,
    width: width
  };

  if (fadeEffect) {
    return _react.default.createElement(_portal.default, null, _react.default.createElement(_reactTransitionGroup.CSSTransition, {
      in: visible,
      timeout: 200,
      classNames: cls + "-fade",
      appear: true
    }, _react.default.createElement("div", {
      style: style,
      ref: ref,
      className: (0, _classnames.default)(className, cls + "-custom")
    }, children)));
  }

  style.display = visible ? '' : 'none';
  return _react.default.createElement(_portal.default, null, _react.default.createElement("div", {
    style: style,
    ref: ref,
    className: (0, _classnames.default)(className, cls + "-custom")
  }, children));
}

var _default = _react.default.forwardRef(PortalAffix);

exports.default = _default;