"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var cls = 're-checkbox';

var Checkbox =
/** @class */
function (_super) {
  __extends(Checkbox, _super);

  function Checkbox(props) {
    var _this = _super.call(this, props) || this;

    _this.onVisibleChange = function () {
      var _a = _this.props,
          disabled = _a.disabled,
          onChange = _a.onChange,
          name = _a.name;

      if (disabled) {
        return;
      }

      var visible = !_this.state.visible;

      if (!('checked' in _this.props)) {
        _this.setState({
          visible: visible
        });
      }

      onChange(visible, name);
    };

    _this.renderBox = function () {
      var _a;

      var _b = _this.props,
          className = _b.className,
          disabled = _b.disabled,
          size = _b.size;
      var visible = _this.state.visible;
      var innerStyle = {
        width: size + "px",
        height: size + "px"
      };
      var iconStyle = {
        width: size * 6 / 16 + "px",
        height: size * 10 / 16 + "px"
      };
      return _react.default.createElement("span", {
        className: (0, _classnames.default)(cls, className, (_a = {}, _a[cls + "-checked"] = visible, _a[cls + "-disabled"] = disabled, _a))
      }, _react.default.createElement("input", {
        className: cls + "-input",
        type: "checkbox",
        onChange: _this.onVisibleChange
      }), _react.default.createElement("span", {
        className: cls + "-inner",
        style: innerStyle
      }, _react.default.createElement("span", {
        className: cls + "-icon",
        style: iconStyle
      })));
    };

    _this.state = {
      visible: props.checked || props.defaultChecked
    };
    return _this;
  }

  Checkbox.getDerivedStateFromProps = function (nextProps, prevState) {
    // 如果父级传了 checked 则更新 state
    if ('checked' in nextProps && nextProps.checked !== prevState.visible) {
      return {
        visible: nextProps.checked
      };
    }

    return null;
  };

  Checkbox.prototype.render = function () {
    var _a;

    var _b = this.props,
        className = _b.className,
        disabled = _b.disabled,
        children = _b.children,
        reverse = _b.reverse; // 只渲染复选框

    if (!children) {
      return this.renderBox();
    }

    return _react.default.createElement("label", {
      className: (0, _classnames.default)(cls + "-wrap", className, (_a = {}, _a[cls + "-reverse"] = reverse, _a[cls + "-disabled"] = disabled, _a))
    }, this.renderBox(), children ? _react.default.createElement("span", {
      className: cls + "-content"
    }, children) : null);
  };

  Checkbox.defaultProps = {
    size: 16,
    disabled: false,
    defaultChecked: false,
    reverse: false
  };
  return Checkbox;
}(_react.default.Component);

var _default = Checkbox;
exports.default = _default;