import React from 'react';
export interface CollapseProps {
    defaultVisible?: boolean;
    visible?: boolean;
    title?: React.ReactNode | ((visible: boolean) => React.ReactNode);
    name?: string;
    appear?: boolean;
    mountOnEnter?: boolean;
    className?: string;
    onChange?: (v: boolean, n?: string) => any;
    onEntered?: (v: HTMLElement, n?: string) => any;
    onExited?: (v: HTMLElement, n?: string) => any;
}
export interface CollapseStates {
    visible: boolean;
    isUserClicked: boolean;
}
export default class Collapse extends React.Component<CollapseProps, CollapseStates> {
    readonly prefixCls = "re-collapse";
    cacheHeight: string;
    static defaultProps: {
        defaultVisible: boolean;
        appear: boolean;
        mountOnEnter: boolean;
    };
    constructor(props: CollapseProps);
    static getDerivedStateFromProps(nextProps: CollapseProps, preState: CollapseStates): {
        visible: boolean;
        isUserClicked: boolean;
    };
    onEnter: (el: HTMLElement) => void;
    onEntering: (el: HTMLElement) => void;
    onEntered: (el: HTMLElement) => void;
    onExit: (el: HTMLElement) => void;
    onExiting: (el: HTMLElement) => void;
    onExited: (el: HTMLElement) => void;
    onChange: () => void;
    renderTitle(): React.DetailedReactHTMLElement<{
        onClick: any;
    }, HTMLElement>;
    /**
     * @returns {*}
     */
    renderContent(): JSX.Element;
    render(): JSX.Element;
}
