"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _classnames = _interopRequireDefault(require("classnames"));

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var Collapse =
/** @class */
function (_super) {
  __extends(Collapse, _super);

  function Collapse(props) {
    var _this = _super.call(this, props) || this;

    _this.prefixCls = 're-collapse';

    _this.onEnter = function (el) {
      _this.cacheHeight = el.offsetHeight + "px";
      el.style.height = '0px';
    };

    _this.onEntering = function (el) {
      el.style.height = _this.cacheHeight;
    };

    _this.onEntered = function (el) {
      el.style.height = '';

      if (_this.props.onEntered) {
        _this.props.onEntered(el, _this.props.name);
      }
    };

    _this.onExit = function (el) {
      el.style.height = el.offsetHeight + "px";
    };

    _this.onExiting = function (el) {
      el.style.height = '0px';
    };

    _this.onExited = function (el) {
      el.style.height = '';

      if (_this.props.onExited) {
        _this.props.onExited(el, _this.props.name);
      }
    };

    _this.onChange = function () {
      var visible = !_this.state.visible;

      if (!('visible' in _this.props)) {
        var isUserClicked = _this.state.isUserClicked || visible;

        _this.setState({
          visible: visible,
          isUserClicked: isUserClicked
        });
      }

      var _a = _this.props,
          onChange = _a.onChange,
          name = _a.name;

      if (onChange) {
        onChange(visible, name);
      }
    };

    _this.state = {
      visible: props.defaultVisible,
      isUserClicked: false
    };
    return _this;
  }

  Collapse.getDerivedStateFromProps = function (nextProps, preState) {
    if ('visible' in nextProps) {
      var isUserClicked = preState.isUserClicked || nextProps.visible;
      return {
        visible: nextProps.visible,
        isUserClicked: isUserClicked
      };
    }

    return null;
  };

  Collapse.prototype.renderTitle = function () {
    var title = this.props.title;

    if (!title) {
      return null;
    }

    var child;

    if (typeof title === 'function') {
      child = title(this.state.visible);
    } else {
      child = _react.default.Children.only(title);
    }

    return _react.default.cloneElement(child, {
      onClick: child.props.onClick || this.onChange
    });
  };
  /**
   * @returns {*}
   */


  Collapse.prototype.renderContent = function () {
    var _a;

    var _b = this.props,
        children = _b.children,
        className = _b.className,
        appear = _b.appear,
        mountOnEnter = _b.mountOnEnter;
    var _c = this.state,
        visible = _c.visible,
        isUserClicked = _c.isUserClicked;
    var cls = this.prefixCls;
    return _react.default.createElement(_reactTransitionGroup.CSSTransition, {
      in: visible,
      timeout: 200,
      classNames: cls + "-fade",
      onEnter: this.onEnter,
      onEntering: this.onEntering,
      onEntered: this.onEntered,
      onExit: this.onExit,
      onExiting: this.onExiting,
      onExited: this.onExited,
      appear: appear,
      mountOnEnter: mountOnEnter
    }, _react.default.createElement("div", {
      className: (0, _classnames.default)(cls, className, (_a = {}, _a[cls + "-hidden"] = !isUserClicked && appear && !visible, _a))
    }, _react.default.createElement("div", {
      className: cls + "-content"
    }, children)));
  };

  Collapse.prototype.render = function () {
    return _react.default.createElement(_react.default.Fragment, null, this.renderTitle(), this.renderContent());
  }; // 默认值


  Collapse.defaultProps = {
    defaultVisible: false,
    appear: true,
    mountOnEnter: false
  };
  return Collapse;
}(_react.default.Component);

var _default = Collapse;
exports.default = _default;