import React from 'react';
import { ModalProps } from '../modal';
export interface ConfirmProps extends Pick<ModalProps, Exclude<keyof ModalProps, 'visible'>> {
    content: React.ReactElement | string | number;
    hiddenCancel?: boolean;
    hiddenOk?: boolean;
    visible?: boolean;
    cancelText?: string;
    okText?: string;
    cancelClassName?: string;
    okClassName?: string;
    onOk?: () => void;
    onCancel?: () => void;
}
export default function Confirm(config: ConfirmProps): {
    destroy: (type?: string) => void;
    forceUpdate: (config: ConfirmProps) => void;
};
