"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactIs = require("react-is");

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var cls = 're-ellipsis';

var getStyle = function getStyle(lines, maxHeight) {
  return {
    WebkitLineClamp: lines,
    maxHeight: maxHeight
  };
};

function Ellipsis(props) {
  var children = props.children,
      maxHeight = props.maxHeight,
      className = props.className,
      _a = props.lines,
      lines = _a === void 0 ? 2 : _a,
      title = props.title;
  var style = getStyle(lines, maxHeight);
  var titleParam = title ? {
    title: title
  } : null; // 当children是单个标签元素时（非文本元素），将直接在该标签上加上style, className，title属性

  if (!(0, _reactIs.isFragment)(children) && (0, _reactIs.isElement)(children)) {
    var child = children;
    return _react.default.cloneElement(child, __assign(__assign({}, titleParam), {
      className: (0, _classnames.default)(cls, className, child.props.className),
      style: __assign(__assign({}, style), child.props.style)
    }));
  }

  return _react.default.createElement("span", __assign({
    className: (0, _classnames.default)(cls, className)
  }, titleParam, {
    style: style
  }), children);
}

var _default = _react.default.memo(Ellipsis);

exports.default = _default;