import React from 'react';
export interface GuideProps {
    visible: boolean;
    onClose: () => void;
    loadablePointer?: boolean;
    img?: string;
    position: 'left' | 'center' | 'right';
    translateX?: number;
    translateY?: number;
    expires?: number;
}
interface GuideStates {
    top: string;
    left: string;
}
export default class Guide extends React.Component<GuideProps, GuideStates> {
    prefixCls: string;
    timer: any;
    imgRef: React.RefObject<HTMLImageElement>;
    static defaultProps: {
        loadablePointer: boolean;
        img: string;
        position: string;
        translateX: number;
        translateY: number;
        expires: number;
    };
    getElement: () => Element | Text;
    constructor(props: GuideProps);
    componentDidMount(): void;
    componentDidUpdate(prevProps: GuideProps): void;
    componentWillUnmount(): void;
    positionPointer(): void;
    changeVisible: () => void;
    onClose: () => void;
    renderMask(): JSX.Element;
    render(): JSX.Element;
}
export {};
