"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactTransitionGroup = require("react-transition-group");

var _string = require("../utils/string");

var prefixCls = 're-mask';

function Mask(_a, ref) {
  var className = _a.className,
      _b = _a.timeout,
      timeout = _b === void 0 ? 300 : _b,
      _c = _a.onClose,
      onClose = _c === void 0 ? function () {} : _c,
      visible = _a.visible; // mousedown和touchstart会一起触发，这里判断后，只执行一次

  var onChangeVisible = _react.default.useCallback(function (event) {
    var touch = (0, _string.isTouchScreen)();

    if (event.type === 'touchstart' && touch || event.type === 'mousedown' && !touch) {
      onClose(event);
    }
  }, [onClose]);

  return _react.default.createElement(_reactTransitionGroup.CSSTransition, {
    in: visible,
    timeout: timeout,
    classNames: prefixCls + "-fade",
    appear: true
  }, _react.default.createElement("div", {
    className: (0, _classnames.default)(prefixCls, className),
    onMouseDown: onChangeVisible,
    onTouchStart: onChangeVisible,
    ref: ref
  }));
}

var _default = _react.default.memo(_react.default.forwardRef(Mask));

exports.default = _default;