import React from 'react';
import { ListenerEventHandler } from '../utils/addEventListener';
import { Position } from './utils';
export interface MoveProps {
    children: React.ReactElement;
    name?: string;
    scalable?: boolean;
    monitorWindowResize?: boolean;
    minScalable?: number;
    maxScalable?: number;
    horizontalPlacement?: 'left' | 'center' | 'right';
    verticalPlacement?: 'top' | 'center' | 'bottom';
    onAfterChange?: (name?: string) => void;
    onClick?: (event: any) => void;
}
export default class Move extends React.Component<MoveProps, any> {
    readonly prefixCls = "re-move";
    static defaultProps: {
        scalable: boolean;
        monitorWindowResize: boolean;
        minScalable: number;
        maxScalable: number;
        horizontalPlacement: string;
        verticalPlacement: string;
    };
    prevElementSize: {
        width: number;
        height: number;
    };
    elementSize: {
        width: number;
        height: number;
    };
    elementParentSize: {
        width: number;
        height: number;
    };
    startObj: {
        left: number;
        top: number;
    };
    prevObj: {
        left: number;
        top: number;
    };
    currentObj: {
        left: number;
        top: number;
    };
    moveObj: {
        left: number;
        top: number;
    };
    prevScaleSize: number;
    currentScaleSize: number;
    scaleStart: number;
    scaleEnd: number;
    isTouchScale: boolean;
    isForceUpdatePlacement: boolean;
    moveRef: React.RefObject<HTMLElement>;
    resizeHandler: ListenerEventHandler | null;
    startHandler: ListenerEventHandler | null;
    mousewheelHandler: ListenerEventHandler | null;
    moveHandler: ListenerEventHandler | null;
    endHandler: ListenerEventHandler | null;
    updateTimer: any;
    componentDidMount(): void;
    componentDidUpdate(prevProps?: MoveProps): void;
    componentWillUnmount(): void;
    clearHandler(): void;
    refreshInfo: (el: any, prevProps: any) => void;
    resetTranslate: (info: Position) => void;
    onMousewheel: (event: any, element: any) => void;
    onStart: (event: any, element: any) => void;
    onMove: (event: any, element: any) => void;
    onEnd: (event: any, element: any) => void;
    checkRange(): {
        isRefresh: boolean;
        nextX: any;
        nextY: any;
        nextScaleSize: number;
    };
    setElementInfo(element: any): void;
    onTransitionEnd: () => void;
    getDomNode(): HTMLElement;
    render(): React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)>) | (new (props: any) => React.Component<any, any, any>)>;
}
