"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _trigger = _interopRequireDefault(require("../trigger"));

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var prefixCls = 're-popover';

function Popover(props) {
  var _a;

  var triggerEl = _react.default.useRef(null);

  var _b = _react.default.useState({}),
      arrowStyle = _b[0],
      setState = _b[1];

  var cls = props.prefixCls || prefixCls;

  var onHidePopup = function onHidePopup() {
    if (triggerEl.current && triggerEl.current.hidePopup) {
      triggerEl.current.hidePopup();
    }
  };

  var onArrowStyleChange = function onArrowStyleChange(value) {
    setState(value);
  };

  var hiddenClose = props.hiddenClose,
      closeIcon = props.closeIcon,
      closeClassName = props.closeClassName,
      innerClassName = props.innerClassName,
      tip = props.tip,
      arrowClassName = props.arrowClassName;

  function renderClose() {
    if (hiddenClose) {
      return null;
    } // 当有自定义的icon时，直接使用,样式需要完全自定义


    if (closeIcon) {
      return _react.default.cloneElement(closeIcon, {
        onClick: onHidePopup
      });
    }

    return _react.default.createElement("i", {
      className: (0, _classnames.default)(cls + "-close", closeClassName),
      onClick: onHidePopup
    }, "\xD7");
  }

  var innerClass = (0, _classnames.default)(cls + "-inner", innerClassName, (_a = {}, _a[cls + "-inner-expand"] = !hiddenClose, _a));

  function renderPopup() {
    return _react.default.createElement(_react.default.Fragment, null, renderClose(), _react.default.createElement("i", {
      className: (0, _classnames.default)(cls + "-arrow", arrowClassName),
      style: arrowStyle
    }), _react.default.createElement("div", {
      className: innerClass
    }, tip));
  }

  return _react.default.createElement(_trigger.default, __assign({}, props, {
    wrapClassName: (0, _classnames.default)(cls + "-wrap ", props.wrapClassName),
    ref: triggerEl,
    hiddenArrow: false,
    popup: renderPopup,
    onArrowStyleChange: onArrowStyleChange
  }), props.children);
}

Popover.defaultProps = {
  hiddenClose: true
};
var _default = Popover;
exports.default = _default;