"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _trigger = _interopRequireDefault(require("../trigger"));

var _string = require("../utils/string");

var __extends = void 0 && (void 0).__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var __spreadArrays = void 0 && (void 0).__spreadArrays || function () {
  for (var s = 0, i = 0, il = arguments.length; i < il; i++) {
    s += arguments[i].length;
  }

  for (var r = Array(s), k = 0, i = 0; i < il; i++) {
    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++) {
      r[k] = a[j];
    }
  }

  return r;
};

var Select =
/** @class */
function (_super) {
  __extends(Select, _super);

  function Select(props) {
    var _this = _super.call(this, props) || this;

    _this.prefixCls = 're-select';
    /**
     * 设置显示与隐藏
     */

    _this.triggerSelect = function (status) {
      if (status === void 0) {
        status = false;
      }

      if (_this.state.visible === status) {
        return;
      }

      _this.setState({
        visible: status
      });
    };

    _this.onTriggerSelect = function () {
      if (_this.props.disabled) {
        return;
      }

      _this.triggerSelect(!_this.state.visible);
    };

    _this.state = {
      visible: false,
      list: [[]]
    };
    return _this;
  }

  Select.getDerivedStateFromProps = function (nextProps) {
    var columnCount = nextProps.columnCount,
        options = nextProps.options;

    if (columnCount <= 1) {
      return {
        list: [__spreadArrays(options)]
      };
    } // 对columnCount值，进行分列，返回一个新的多维数组


    var list = [];
    var maxRow = Math.ceil(options.length / columnCount); // 分列

    for (var i = 1; i <= columnCount; i++) {
      var startIndex = maxRow * (i - 1);
      var endIndex = maxRow * i;
      var columnList = options.slice(startIndex, endIndex);
      list.push(__spreadArrays(columnList));
    }

    return {
      list: list
    };
  };

  Select.prototype.onSelecting = function (ev, item) {
    if (ev) {
      ev.stopPropagation();
    }

    var _a = this.props,
        onChange = _a.onChange,
        value = _a.value,
        name = _a.name;

    if (item.value !== value) {
      onChange(item, name);
    }

    this.triggerSelect(false);
  };

  Select.prototype.renderTitle = function () {
    var title = this.props.title;

    if (!title) {
      return null;
    }

    var child = _react.default.Children.only(title);

    return _react.default.cloneElement(child, {
      className: (0, _classnames.default)(this.prefixCls + "-title", child.props.className)
    });
  };

  Select.prototype.renderBottom = function () {
    var bottom = this.props.bottom;

    if (!bottom) {
      return null;
    }

    var child = _react.default.Children.only(bottom);

    return _react.default.cloneElement(child, {
      className: (0, _classnames.default)(this.prefixCls + "-bottom", child.props.className)
    });
  };
  /**
   * 下拉框内容
   */


  Select.prototype.getSelectPopup = function () {
    var _this = this;

    var cls = this.prefixCls;
    return _react.default.createElement(_react.default.Fragment, null, this.renderTitle(), _react.default.createElement("div", {
      className: cls + "-content"
    }, this.state.list.map(function (col, index) {
      return _react.default.createElement("ul", {
        className: cls + "-col",
        key: index
      }, col.map(function (item) {
        var _a;

        if (item.unselect) {
          return _react.default.createElement("li", {
            key: item.value + "1",
            className: (0, _classnames.default)(item.className, cls + "-unselect")
          }, item.name);
        }

        return _react.default.createElement("li", {
          key: item.value,
          className: (0, _classnames.default)(item.className, (_a = {}, _a[cls + "-active"] = item.value === _this.props.value, _a)),
          onClick: function onClick(ev) {
            return _this.onSelecting(ev, item);
          }
        }, item.name);
      }));
    })), this.renderBottom());
  };
  /**
   * 根据value获取当前的name,并显示出来
   * @returns {*}
   */


  Select.prototype.getCurrentName = function () {
    var _a = this.props,
        options = _a.options,
        value = _a.value;

    if (!(0, _string.isBlank)(value)) {
      var currentItem = options.find(function (item) {
        return item.value === value;
      });

      if (currentItem) {
        return currentItem.actualName || currentItem.name;
      }
    }

    return null;
  };

  Select.prototype.render = function () {
    var _a, _b;

    var visible = this.state.visible;

    var _c = this.props,
        className = _c.className,
        placeholder = _c.placeholder,
        disabled = _c.disabled,
        hiddenIcon = _c.hiddenIcon,
        icon = _c.icon,
        dropClassName = _c.dropClassName,
        extraProps = __rest(_c, ["className", "placeholder", "disabled", "hiddenIcon", "icon", "dropClassName"]);

    var cls = this.prefixCls;
    var currentName = this.getCurrentName();
    return _react.default.createElement(_trigger.default, __assign({}, extraProps, {
      wrapClassName: (0, _classnames.default)(cls + "-wrap", dropClassName),
      visible: visible,
      trigger: "click",
      isTransformHorizontalDirection: true,
      rootToPopupSpacing: 0,
      popupLimitSpacing: 10,
      popup: this.getSelectPopup(),
      onVisibleChange: this.triggerSelect
    }), _react.default.createElement("div", {
      className: (0, _classnames.default)([cls + "-input-group", className, (_a = {}, _a[cls + "-active"] = visible, _a.disabled = disabled, _a)]),
      onClick: this.onTriggerSelect
    }, _react.default.createElement("div", {
      className: (0, _classnames.default)([cls + "-input-control", (_b = {}, _b[cls + "-focused"] = visible, _b[cls + "-empty"] = !currentName, _b)])
    }, currentName || placeholder), hiddenIcon ? null : _react.default.createElement("span", {
      className: cls + "-icon"
    }, typeof icon === 'function' ? icon() : icon)));
  }; // 默认值


  Select.defaultProps = {
    title: null,
    icon: _react.default.createElement("svg", {
      viewBox: "64 64 896 896",
      "data-icon": "down",
      fill: "currentColor",
      width: "1em",
      height: "1em",
      "aria-hidden": "true",
      focusable: "false"
    }, _react.default.createElement("path", {
      d: "M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5 0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39 17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z"
    })),
    placeholder: 'Please select',
    columnCount: 1,
    maxHeight: 310,
    placement: 'bottomLeft',
    disabled: false,
    hiddenIcon: false,
    isMinRootWidth: false,
    isMaxRootWidth: false
  };
  return Select;
}(_react.default.Component);

var _default = Select;
exports.default = _default;