"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = addEventListener;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _reactDom = _interopRequireDefault(require("react-dom"));

function addDOMEventListener(target, eventType, callback, option) {
  if (target && target.addEventListener) {
    var useCapture_1 = false;

    if ((0, _typeof2.default)(option) === 'object') {
      useCapture_1 = option.capture || false;
    } else if (typeof option === 'boolean') {
      useCapture_1 = option;
    }

    target.addEventListener(eventType, callback, option || false);
    return {
      remove: function remove() {
        target.removeEventListener(eventType, callback, useCapture_1);
      }
    };
  }

  return null;
}

function addEventListener(target, eventType, cb, option) {
  // setState 强制批量处理
  var callback = _reactDom.default.unstable_batchedUpdates ? function run(e) {
    _reactDom.default.unstable_batchedUpdates(cb, e);
  } : cb;
  return addDOMEventListener(target, eventType, callback, option);
}