"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _compileUrl = _interopRequireDefault(require("./compileUrl"));

var _interceptor = _interopRequireDefault(require("./interceptor"));

var _filterUrlAndOptions = _interopRequireDefault(require("./filterUrlAndOptions"));

var Ajax =
/** @class */
function () {
  function Ajax() {}
  /**
   * GET
   * @param url
   * @param params
   * @param options
   */


  Ajax.get = function (url, params, options) {
    var _a = (0, _compileUrl.default)(url, params),
        urlWithQuery = _a.urlWithQuery,
        surplusParams = _a.surplusParams;

    var _b = (0, _filterUrlAndOptions.default)(urlWithQuery, options, {
      method: 'get'
    }),
        allUrl = _b.allUrl,
        fetchOptions = _b.fetchOptions,
        requestUse = _b.requestUse,
        responseUse = _b.responseUse,
        beforeRequest = _b.beforeRequest,
        afterResponse = _b.afterResponse,
        abortController = _b.abortController,
        retryCount = _b.retryCount,
        retryCondition = _b.retryCondition,
        setCacheInfo = _b.setCacheInfo,
        cacheNamespace = _b.cacheNamespace,
        cacheMethod = _b.cacheMethod;

    return (0, _interceptor.default)(allUrl, fetchOptions, {
      surplusParams: surplusParams,
      requestUse: requestUse,
      responseUse: responseUse,
      beforeRequest: beforeRequest,
      afterResponse: afterResponse,
      abortController: abortController,
      retryCount: retryCount,
      retryCondition: retryCondition,
      setCacheInfo: setCacheInfo,
      cacheNamespace: cacheNamespace,
      cacheMethod: cacheMethod
    });
  };
  /**
   * POST
   * @param url
   * @param data 请求体
   * @param params
   * @param options
   * @returns {*}
   */


  Ajax.post = function (url, data, params, options) {
    var _a = (0, _compileUrl.default)(url, params),
        urlWithQuery = _a.urlWithQuery,
        surplusParams = _a.surplusParams;

    var _b = (0, _filterUrlAndOptions.default)(urlWithQuery, options, {
      method: 'post',
      body: JSON.stringify(data)
    }),
        allUrl = _b.allUrl,
        fetchOptions = _b.fetchOptions,
        requestUse = _b.requestUse,
        responseUse = _b.responseUse,
        beforeRequest = _b.beforeRequest,
        afterResponse = _b.afterResponse,
        abortController = _b.abortController,
        retryCount = _b.retryCount,
        retryCondition = _b.retryCondition,
        setCacheInfo = _b.setCacheInfo,
        cacheNamespace = _b.cacheNamespace,
        cacheMethod = _b.cacheMethod;

    return (0, _interceptor.default)(allUrl, fetchOptions, {
      surplusParams: surplusParams,
      requestUse: requestUse,
      responseUse: responseUse,
      beforeRequest: beforeRequest,
      afterResponse: afterResponse,
      abortController: abortController,
      retryCount: retryCount,
      retryCondition: retryCondition,
      setCacheInfo: setCacheInfo,
      cacheNamespace: cacheNamespace,
      cacheMethod: cacheMethod
    });
  };
  /**
   * DELETE
   * @param url
   * @param params
   * @param options
   * @returns {*}
   */


  Ajax.delete = function (url, params, options) {
    var _a = (0, _compileUrl.default)(url, params),
        urlWithQuery = _a.urlWithQuery,
        surplusParams = _a.surplusParams;

    var _b = (0, _filterUrlAndOptions.default)(urlWithQuery, options, {
      method: 'delete'
    }),
        allUrl = _b.allUrl,
        fetchOptions = _b.fetchOptions,
        requestUse = _b.requestUse,
        responseUse = _b.responseUse,
        beforeRequest = _b.beforeRequest,
        afterResponse = _b.afterResponse,
        abortController = _b.abortController,
        retryCount = _b.retryCount,
        retryCondition = _b.retryCondition,
        setCacheInfo = _b.setCacheInfo,
        cacheNamespace = _b.cacheNamespace,
        cacheMethod = _b.cacheMethod;

    return (0, _interceptor.default)(allUrl, fetchOptions, {
      surplusParams: surplusParams,
      requestUse: requestUse,
      responseUse: responseUse,
      beforeRequest: beforeRequest,
      afterResponse: afterResponse,
      abortController: abortController,
      retryCount: retryCount,
      retryCondition: retryCondition,
      setCacheInfo: setCacheInfo,
      cacheNamespace: cacheNamespace,
      cacheMethod: cacheMethod
    });
  };
  /**
   * PUT
   * @param url
   * @param data
   * @param params
   * @param options
   * @returns {*}
   */


  Ajax.put = function (url, data, params, options) {
    var _a = (0, _compileUrl.default)(url, params),
        urlWithQuery = _a.urlWithQuery,
        surplusParams = _a.surplusParams;

    var _b = (0, _filterUrlAndOptions.default)(urlWithQuery, options, {
      method: 'put',
      body: JSON.stringify(data)
    }),
        allUrl = _b.allUrl,
        fetchOptions = _b.fetchOptions,
        requestUse = _b.requestUse,
        responseUse = _b.responseUse,
        beforeRequest = _b.beforeRequest,
        afterResponse = _b.afterResponse,
        abortController = _b.abortController,
        retryCount = _b.retryCount,
        retryCondition = _b.retryCondition,
        setCacheInfo = _b.setCacheInfo,
        cacheNamespace = _b.cacheNamespace,
        cacheMethod = _b.cacheMethod;

    return (0, _interceptor.default)(allUrl, fetchOptions, {
      surplusParams: surplusParams,
      requestUse: requestUse,
      responseUse: responseUse,
      beforeRequest: beforeRequest,
      afterResponse: afterResponse,
      abortController: abortController,
      retryCount: retryCount,
      retryCondition: retryCondition,
      setCacheInfo: setCacheInfo,
      cacheNamespace: cacheNamespace,
      cacheMethod: cacheMethod
    });
  };

  return Ajax;
}();

var _default = Ajax;
exports.default = _default;