import { Options, RequestUse, ResponseUse } from './Config';
declare type MethodOptions = {
    method: 'get' | 'post' | 'delete' | 'put';
    body?: string;
};
export interface FilterOptions extends Partial<Options> {
    beforeRequest?: RequestUse<any>;
    afterResponse?: ResponseUse<any>;
    cancelable?: boolean;
}
export default function filterUrlAndOptions(url: string, options: FilterOptions, methodOptions: MethodOptions): {
    allUrl: string;
    requestUse: RequestUse<any>;
    responseUse: ResponseUse<any>;
    beforeRequest: RequestUse<any>;
    afterResponse: ResponseUse<any>;
    fetchOptions: FilterOptions & MethodOptions & {
        signal?: AbortSignal;
    };
    abortController: AbortController;
    retryCount: number;
    retryCondition: import("./Config").RetryCondition;
    setCacheInfo: import("./Config").SetCacheInfo;
    cacheNamespace: string;
    cacheMethod: import("./Config").CacheMethod;
};
export {};
