"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = filterUrlAndOptions;

var _Config = _interopRequireDefault(require("./Config"));

var _abort = _interopRequireDefault(require("./abort"));

var _merge = _interopRequireDefault(require("./merge"));

function filterUrlAndOptions(url, options, methodOptions) {
  var fetchOptions = (0, _merge.default)(_Config.default.fetchOptions, options, methodOptions);
  var baseUrl = fetchOptions.baseUrl || _Config.default.baseUrl;
  delete fetchOptions.baseUrl;
  var requestUse = fetchOptions.requestUse || _Config.default.requestUse;
  delete fetchOptions.requestUse;
  var responseUse = fetchOptions.responseUse || _Config.default.responseUse;
  delete fetchOptions.responseUse;
  var retryCount = fetchOptions.retryCount || _Config.default.retryCount;
  delete fetchOptions.retryCount;
  var retryCondition = fetchOptions.retryCondition || _Config.default.retryCondition;
  delete fetchOptions.retryCondition;
  var setCacheInfo = fetchOptions.setCacheInfo;
  delete fetchOptions.setCacheInfo;
  var cacheNamespace = fetchOptions.cacheNamespace || _Config.default.cacheNamespace;
  delete fetchOptions.cacheNamespace;
  var cacheMethod = fetchOptions.cacheMethod || _Config.default.cacheMethod;
  delete fetchOptions.cacheMethod;
  var beforeRequest = fetchOptions.beforeRequest;
  delete fetchOptions.beforeRequest;
  var afterResponse = fetchOptions.afterResponse;
  delete fetchOptions.afterResponse;
  var abortController;

  if (fetchOptions.cancelable) {
    delete fetchOptions.cancelable;

    var _a = (0, _abort.default)(),
        controller = _a.controller,
        signal = _a.signal;

    if (signal) {
      fetchOptions.signal = signal;
      abortController = controller;
    }
  }

  return {
    allUrl: "" + baseUrl + url,
    requestUse: requestUse,
    responseUse: responseUse,
    beforeRequest: beforeRequest,
    afterResponse: afterResponse,
    fetchOptions: fetchOptions,
    abortController: abortController,
    retryCount: retryCount,
    retryCondition: retryCondition,
    setCacheInfo: setCacheInfo,
    cacheNamespace: cacheNamespace,
    cacheMethod: cacheMethod
  };
}