"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = merge;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _string = require("../string");

function customForEach(obj, fn) {
  if (obj === null || typeof obj === 'undefined') {
    return;
  }

  if ((0, _typeof2.default)(obj) !== 'object') {
    obj = [obj];
  }

  if ((0, _string.isArray)(obj)) {
    for (var i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        fn.call(null, obj[key], key, obj);
      }
    }
  }
}

function merge() {
  var args = [];

  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }

  var result = {};

  function assignValue(val, key) {
    if ((0, _string.isObject)(result[key]) && (0, _string.isObject)(val)) {
      result[key] = merge(result[key], val);
    } else if ((0, _string.isObject)(val)) {
      result[key] = merge({}, val);
    } else if ((0, _string.isArray)(val)) {
      result[key] = val.slice();
    } else if (!(0, _string.isBlank)(val)) {
      result[key] = val;
    }
  }

  for (var i = 0, l = args.length; i < l; i++) {
    customForEach(args[i], assignValue);
  }

  return result;
}