import { Config, Context, LogLevel } from './ApplicationInsights';
export interface LoggerConfig extends Config {
    performance: boolean;
    performanceMinFid: number;
    performanceMinLcp: number;
    performanceMinCls: number;
}
export default class Logger {
    static appInsights: any;
    /**
     * 初始化Logger
     */
    static initializeLogger(config: LoggerConfig, context: Context): void;
    /**
     * 自定义日志类型和信息
     * @param level
     * @param value
     * @param label
     * @param updateId
     */
    static customTrack(level: LogLevel, value?: object, label?: string, updateId?: string): any;
    /**
     * 依赖项日志收集
     * @param value
     */
    static trackDependency(value?: object): void;
    /**
     * 异常收集
     * @param value
     */
    static trackException(value?: {}): void;
    /**
     * 文件加载异常收集
     * @param value
     */
    static trackFileException(value?: {}): void;
    /**
     * 页面性能收集
     */
    static trackPerformance(value?: {}, updateId?: string): string;
    /**
     * 用户点击事件收集
     * @param value
     */
    static trackClickEvent(value?: {}): void;
}
