"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = setPerformance;

var _webVitals = require("web-vitals");

var _collectInfo = _interopRequireDefault(require("./collectInfo"));

var _string = require("../string");

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

function setPerformance(trackPerformance, minFid, minLcp, minCls) {
  if (!window.PerformanceObserver || !window.navigator || !window.navigator.storage || !window.navigator.storage.estimate || !window.navigator.serviceWorker) {
    return;
  } // 性能统计


  var performanceParams = {
    response: {}
  };
  var trackId;
  var hasTrackAllInfo = false;

  var callback = function callback(info) {
    performanceParams[info.name] = info.value;

    if (info.desc) {
      performanceParams.response[info.name] = info.desc;
    } // 防止重复收集


    if (hasTrackAllInfo) {
      return;
    } // 用户操作页面才收集，否则收集的信息没有多少价值


    if (!(0, _string.isBlank)(performanceParams.FID) && !(0, _string.isBlank)(performanceParams.LCP) && !(0, _string.isBlank)(performanceParams.CLS) && (performanceParams.FID > minFid || performanceParams.LCP > minLcp || performanceParams.CLS > minCls)) {
      hasTrackAllInfo = true;
      trackId = trackPerformance(__assign(__assign({}, performanceParams), {
        response: JSON.stringify(performanceParams.response)
      }), trackId);
    }
  };

  (0, _webVitals.getLCP)(function (info) {
    return _collectInfo.default.lcp(info, minLcp, callback);
  });
  (0, _webVitals.getFID)(function (info) {
    return _collectInfo.default.fid(info, minFid, callback);
  });
  (0, _webVitals.getCLS)(function (info) {
    return _collectInfo.default.cls(info, minCls, callback);
  });
  (0, _webVitals.getTTFB)(function (info) {
    return _collectInfo.default.ttfb(info, callback);
  });
  (0, _webVitals.getFCP)(function (info) {
    return _collectInfo.default.fcp(info, callback);
  });
}