"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.scrollTo = scrollTo;
exports.scrollYAnimation = scrollYAnimation;

var _string = require("./string");

function scrollTo(x, y, forbidBehavior) {
  if (x === void 0) {
    x = 0;
  }

  if (y === void 0) {
    y = 0;
  }

  if (!window || !window.scrollTo) {
    return;
  }

  if (forbidBehavior) {
    window.scrollTo(x, y);
    return;
  }

  try {
    window.scrollTo({
      left: x,
      top: y,
      behavior: 'smooth'
    });
  } catch (e) {
    window.scrollTo(x, y);
  }
}

function scrollYAnimation(targetY, currentY, callback) {
  if (targetY === void 0) {
    targetY = 0;
  }

  var isClearAnimation = false;

  function run(targetY, currentY, callback) {
    if (isClearAnimation) {
      return;
    }

    if ((0, _string.isBlank)(currentY)) {
      currentY = document.body.scrollTop || document.documentElement.scrollTop;
    } // 获取步长 确定移动方向(正负值) 步长应该是越来越小的，缓动的算法。


    var step = (targetY - currentY) / 5; // 对步长进行二次加工(大于0向上取整,小于0项下取整)

    step = step > 0 ? Math.ceil(step) : Math.floor(step);
    currentY += step; // 检测缓动动画有没有停止

    if (Math.abs(targetY - currentY) <= Math.abs(step)) {
      scrollTo(0, targetY, true);

      if (callback) {
        callback();
      }
    } else {
      scrollTo(0, currentY, true);
      window.requestAnimationFrame(function () {
        return run(targetY, currentY, callback);
      });
    }
  }

  run(targetY, currentY, callback);
  return {
    remove: function remove() {
      isClearAnimation = true;
    }
  };
}