"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = throttleWithRAF;

var _string = require("./string");

var requestAnimationFrame = _string.canUseDOM ? window.requestAnimationFrame || window.webkitRequestAnimationFrame : function () {};

function throttleWithRAF(fn) {
  var ticking = false;
  var callback;

  var update = function update() {
    var arg = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      arg[_i] = arguments[_i];
    }

    fn.apply(void 0, arg);
    ticking = false;
  };

  return function () {
    var arg = [];

    for (var _i = 0; _i < arguments.length; _i++) {
      arg[_i] = arguments[_i];
    }

    if (!ticking) {
      callback = callback || function () {
        return update.apply(void 0, arg);
      };

      requestAnimationFrame(callback);
    }

    ticking = true;
  };
}